Unit AtariDbg;

Interface

Uses G320,Objects,Profile;

Const
  LatchQueueSize = 16;
  GameScreenSize = 160 * 200;
  _32BIT_OPERAND = $66;

Type
  BPtr        = ^Byte;
  PBankSwitch = ^TBankSwitch;
  TBankSwitch = Array[0..8192] Of Byte;
  TIA_RegList = Array[0..$3F] Of Byte;
  TGameRes    = (gr320x200,gr320x204,
                 gr160x200A,gr160x204A,gr160x215A,gr160x250A,gr160x305A,
                 gr160x200B,gr160x204B,gr160x215B,gr160x250B,gr160x305B);
  TSave = Record
    TIA_Regs                       : TIA_RegList;
    TIA_Count                      : Integer;
    Old_TIA_Count                  : Integer;
    TIA_Scan                       : Integer;
    ObjectLoc                      : Array[0..16] Of LongInt;
    ObjectPix                      : Array[0..16] Of LongInt;
    Player0Size                    : LongInt;
    Player1Size                    : LongInt;
    Player0Size160                 : LongInt;
    Player1Size160                 : LongInt;
    Player0Size128                 : LongInt;
    Player1Size128                 : LongInt;
    Missile0Size                   : LongInt;
    Missile1Size                   : LongInt;
    Missile0Size160                : LongInt;
    Missile1Size160                : LongInt;
    Missile0SizeNum                : LongInt;
    Missile1SizeNum                : LongInt;
    Addr                           : LongInt;
    ColorLum                       : Array[0..3] Of Word;
    BallSize                       : LongInt;
    BallSize160                    : LongInt;
    CLW                            : LongInt;
    CRW                            : LongInt;
    Input_Byte                     : Array[0..$F] Of Byte;
    DispJump                       : LongInt;
    DoHMOVE                        : Boolean;
    LineStart                      : Word;
    LastScan                       : LongInt;
    NewScan                        : LongInt;
    TopVBLANK                      : Boolean;
    TIA_Latch_Value                : Array[0..LatchQueueSize - 1] Of Integer;
    TIA_Latch_Reg                  : Array[0..LatchQueueSize - 1] Of Byte;
    TIA_Latch_Count                : Array[0..LatchQueueSize - 1] Of Integer;
    TIA_Latch_Scan                 : Array[0..LatchQueueSize - 1] Of Integer;
    TIA_Latch_Queue                : Integer;
    TIA_Latch_RegCount             : Array[0..$2C] Of Integer;
    MaxRows                        : Word;
    Missile0Wrap                   : LongInt;
    Missile1Wrap                   : LongInt;

{ ----------------------------------------------------------------- }

    _Player0Size                   : LongInt;
    _Player1Size                   : LongInt;
    ResetPlayer0Size128            : LongInt;
    ResetPlayer1Size128            : LongInt;
    OldMissile0SizeNum             : LongInt;
    OldMissile1SizeNum             : LongInt;
    OldPlayer0Size128              : LongInt;
    OldPlayer1Size128              : LongInt;
    Missile0Adjust                 : LongInt;
    Missile1Adjust                 : LongInt;
    AddCycle                       : LongInt;
    TimerInterval                  : LongInt;
    TimerValue                     : LongInt;
    TimerShift                     : LongInt;
    TimerX                         : LongInt;
{    TimerSize                      : LongInt;}
    OrigTimer                      : LongInt;
    TimerElapsed                   : LongInt;
    ReadTime                       : LongInt;
    Write_TIA                      : LongInt;
    ObjectSet                      : LongInt;
    Save_BX                        : LongInt;
    ColorOrBW                      : LongInt;
    Difficulty1                    : LongInt;
    Difficulty2                    : LongInt;
    PaddleGround0                  : LongInt;
    PaddleGround1                  : LongInt;
    PaddleGround2                  : LongInt;
    PaddleGround3                  : LongInt;
    OldPaddleGround0               : LongInt;
    OldPaddleGround1               : LongInt;
    OldPaddleGround2               : LongInt;
    OldPaddleGround3               : LongInt;
    KeyColumn                      : LongInt;
    Indy500                        : Array[0..1] Of Word;
    OldObjectLoc                   : Array[0..16] Of LongInt;
    NewObjectLoc                   : Array[0..16] Of LongInt;
    MegaBoy                        : Array[0..15] Of Byte;
    ROMSize                        : LongInt;
    TimerDone                      : Boolean;
    GRP0Latch                      : Byte;
    GRP1Latch                      : Byte;
    MegaBoyNum                     : Word;
    OldNUSIZ0                      : Byte;
    OldNUSIZ1                      : Byte;
    OldHMxx                        : Array[0..4] Of Byte;
    ResetOffset                    : Array[0..4] Of Word;
    ResetOfs                       : Word;
    LastVBLANK                     : Integer;
    BallLatch                      : Byte;
    TIA_Latch_ResetPlayer0Size128  : LongInt;
    TIA_Latch_ResetPlayer1Size128  : LongInt;
    TIA_Latch_Missile0SizeNum      : LongInt;
    TIA_Latch_Missile1SizeNum      : LongInt;
    Latched                        : Boolean;
    M0Bug                          : Boolean;
    M0BugCount                     : Byte;
    FixTimer                       : Byte;
    FixTimerNum                    : Byte;
    VBLANKOff                      : Boolean;
    Palette                        : Byte;
    Controller                     : TController;
    FMRealScale                    : Array[0..8] Of Word;
    FMVoc                          : Array[0..8] Of Byte;
    FMFreq                         : Array[0..8] Of Word;
    BankSwitch                     : TBankSwitch;
    VAddAdjust                     : Integer;
    VAdd                           : Integer;
    VUserAdd                       : Integer;
    CurrentBank                    : Byte;
    BankStart                      : Word;
    BankSize                       : Word;
    OldStart                       : Word;
    _CTRLPF                        : Byte;
    OldByte                        : Byte;
    SPBankNum                      : Byte;
    StarpathWriteValue             : Byte;
    StarpathWrite                  : Boolean;
    OldDoHMOVE                     : Boolean;
    HMOVECount                     : LongInt;
    Cart                           : TCart;
    TigerLimit                     : Byte;
    SCLimit                        : Byte;
    MNetworkRAM                    : Byte;
    StarpathLastAddr               : Word;
    Hi3                            : Word;
    _6507_P                        : Byte;
    _6507_A                        : Byte;
    _6507_X                        : Byte;
    _6507_Y                        : Byte;
    _6507_S                        : Byte;
    _6507_PC                       : Word;
    UserSetPos                     : Integer;
    ObjectMove                     : Array[0..16] Of LongInt;
    MissedHMOVE                    : Array[0..32] Of Boolean;

{ --------------------- From SPUnit ------------------------ }

    SPBank   : Byte;
    SPSearch : Word;
    SPBoot   : Boolean;

    WaveLen : Array[1..4] Of Byte; { The fourth byte is unused in these arrays }
    Pulse   : Array[1..4] Of Byte;
    Phase   : Array[1..4] Of Byte;
    Signal  : Array[1..4] Of Byte;
    Wave    : Array[1..4] Of Byte;

    LineDelay      : Word;
    LineDelayFirst : Boolean;
    LineDelayMax   : Word;
  End;

Const
  HiRes : Boolean = False;

Var
  FontSmPtr : Pointer;
  ModeD     : Array[0..5] Of Byte;

Function Debug(Buf: Pointer; Var PC: Word; Var P,A,X,Y,S: Byte;
               ROMBackup: Pointer; GameRes: TGameRes;
               Var HaltLine: Integer; Var BreakExpColl: PCollection;
               Var Game: TSave{; SN1,SN2,SN3,SN4: Word}): Boolean;

Function  IntToStr(L: LongInt): String;
Function  UpperCase(St: String): String;
Function  Exist(FileName: String): Boolean;
Function  Trim(St: String): String;
Function  ValHex(St: String): LongInt;
Procedure Set160ColsA;
Procedure Set160ColsB;

{Procedure Set320Cols;}
Procedure Set200Rows;
Procedure Set205Rows;
Procedure Set210Rows;
Procedure Set215Rows;
Procedure Set240Rows;

Procedure SetRows(Rows: Word);
Procedure Go_Mode(Mode: Byte);
{
Procedure Set160RowsA(Rows: Word);
Procedure Set160RowsB(Rows: Word);
}
Implementation

Uses Crt,Dos,HexWrite,SmModeX,Vectors,AtariDis,Equation,AtariMnu;

Const
  VSYNC   = 0;
  VBLANK  = 1;
  WSYNC   = 2;
  RSYNC   = 3;
  NUSIZ0  = 4;
  NUSIZ1  = 5;
  COLUP0  = 6;
  COLUP1  = 7;
  COLUPF  = 8;
  COLUBK  = 9;
  CTRLPF  = $0A;
  REFP0   = $0B;
  REFP1   = $0C;
  PF0     = $0D;
  PF1     = $0E;
  PF2     = $0F;
  RESP0   = $10;
  RESP1   = $11;
  RESM0   = $12;
  RESM1   = $13;
  RESBL   = $14;
  AUDC0   = $15;
  AUDC1   = $16;
  AUDF0   = $17;
  AUDF1   = $18;
  AUDV0   = $19;
  AUDV1   = $1A;
  GRP0    = $1B;
  GRP1    = $1C;
  ENAM0   = $1D;
  ENAM1   = $1E;
  ENABL   = $1F;
  HMP0    = $20;
  HMP1    = $21;
  HMM0    = $22;
  HMM1    = $23;
  HMBL    = $24;
  VDELP0  = $25;
  VDELP1  = $26;
  VDELBL  = $27;
  RESMP0  = $28;
  RESMP1  = $29;
  HMOVE   = $2A;
  HMCLR   = $2B;
  CXCLR   = $2C;
  SWCHA1  = $280;
  SWACNT1 = $281;
  SWCHB1  = $282;
  SWBCNT1 = $283;
  INTTIM1 = $284;
  INTTIM3 = $285;
  TIM1T1  = $294;
  TIM2T1  = $295;
  TIM3T1  = $296;
  TIM4T1  = $297;
  SWCHA2  = $380;
  SWACNT2 = $381;
  SWCHB2  = $382;
  SWBCNT2 = $383;
  INTTIM2 = $384;
  TIM1T2  = $394;
  TIM2T2  = $395;
  TIM3T2  = $396;
  TIM4T2  = $397;

  Index_Player0Set  = 1;
  Index_Player1Set  = 2;
  Index_Missile0Set = 4;
  Index_Missile1Set = 8;
  Index_BallSet     = 16;

Const
  NormTextColor = 0;
  HiTextColor   = 30;
  PCTextColor   = 246;
  HelpTextColor = 10;
  HelpHiColor   = 28;
  LineColor     = 14;
  BackColor     = 4;
  DisasmColor   = 174;
  FlagsColor    = 250;{254;}
  RegsColor     = 108;{110;}
  DataColor     = 158;
  ScrDatColor   = 90;
  TIA_Color     = 154;
  TextBGColor   = 148;
  PopupColor    = 10;
  HelpColor     = 132;

  TextStart     = 2;
  TextHeight    = 8;
  DisasmLines   = 16;
  HRDisasmLines = 32;
  DataLines     = 8;
  SmFontSize    = 1024;

Var
  Win         : Pointer;
{  Win         : _WindowPtr;}
  OldExitProc : Pointer;
{  LineWinData : Pointer;}
  BreakExp    : String;

Procedure Go_Mode(Mode: Byte);
Var Regs: Registers;
Begin
  Regs.AH := 0;
  Regs.AL := Mode;
  Intr($10,Regs);
End; { Go_Mode }

Function IntToStr(L: LongInt): String;
Var St: String;
Begin
  Str(L,St);
  IntToStr := St;
End; { IntToStr }


Function UpperCase(St: String): String;
Var I: Byte;
Begin
  If St = '' Then
  Begin
    UpperCase := '';
    Exit;
  End;
  For I := 1 To Length(St) Do St[I] := UpCase(St[I]);
  UpperCase := St;
End; { UpperCase }


Function ValHex(St: String): LongInt;
Var
  Initial : LongInt;
  I       : Integer;
  Value   : LongInt;

Begin
  If St = '' Then
  Begin
    ValHex := -1;
    Exit;
  End;
{  If Length(St) > 8 Then St := Copy(St,1,8);}
  Value   := 0;
  St      := UpperCase(St);
  I       := (Length(St) - 1) * 4;
  Asm
    DB    _32BIT_OPERAND
    SUB   AX,AX
    MOV   AX,1
    MOV   CX,WORD PTR I
    DB    _32BIT_OPERAND
    SHL   AX,CL
    DB    _32BIT_OPERAND
    MOV   WORD PTR Initial,AX
  End; { Asm }
  For I := 1 To Length(St) Do
  Begin
    If St[I] In ['0'..'9'] Then Inc(Value,Initial * (Ord(St[I]) - Ord('0')))
     Else
      If St[I] In ['A'..'F'] Then Inc(Value,Initial * (Ord(St[I]) - Ord('A') + 10))
       Else
       Begin
         ValHex := -1;
         Exit;
       End;
    Initial := Initial Shr 4;
  End; { For I }
  ValHex := Value;
End; { ValHex }


Function Trim(St: String): String;
Begin
  While (St <> '') And (St[1]          = ' ') Do St := Copy(St,2,Length(St) - 1);
  While (St <> '') And (St[Length(St)] = ' ') Do St := Copy(St,1,Length(St) - 1);
  Trim := St;
End; { Trim }


Function Exist(FileName: String): Boolean;
Var Fil: File;
Begin
  Assign(Fil,FileName);
  {$I-}
  Reset(Fil);
  {$I+}
  If (IOResult = 0) Then
  Begin
    Close(Fil);
    Exist := True;
  End
  Else Exist := False;
End; { Exist }


{$F+}
Procedure NewExitProc;
Begin
  FreeMem(FontSmPtr,SmFontSize);
  If Win <> Nil Then FreeMem(Win,GameScreenSize);
  ExitProc := OldExitProc;
End; { NewExitProc }
{$F-}


Function LoadSmallFont: Boolean;
Var F: File;
Begin
  If Exist('PCAE.FNT') Then
  Begin
    GetMem(FontSmPtr,SmFontSize);
    Assign(F,'PCAE.FNT');
    Reset(F,1);
    BlockRead(F,FontSmPtr^,SmFontSize);
    Close(F);
    LoadSmallFont := True;
  End
  Else LoadSmallFont := False;
End; { LoadSmallFont }


Procedure ErrorLoadingSmallFont;
Var CurPath: String;
Begin
  GetDir(0,CurPath);
  ErrorFileNotFound(CurPath,'PCAE.FNT');
  Halt;
End; { ErrorLoadingSmallFont }


Const
  VGA_SEGMENT   = $A000;
  SC_INDEX      = $3C4;   { Sequence Controller Index register   }
  GC_INDEX      = $3CE;   { Graphics Controller Index register   }
  CRTC_INDEX    = $3D4;   { CRT Controller Index register        }
  MISC_OUTPUT   = $3C2;   { Miscellaneous Output Register        }
  MISC_INPUT    = $3CC;   { Miscellaneous Input Register         }
  MISCELLANEOUS = 6;      { Moscellaneous register index in GC   }
  MEMORY_MODE   = 4;      { Memory Mode register index in SC     }
  GRAPHICS_MODE = 5;      { Graphics Mode register index in GC   }
  MAX_SCAN_LINE = 9;      { Maximum Scan Line reg index in CRTC  }
  UNDERLINE     = $14;    { Underline Location reg index in CRTC }
  MODE_CONTROL  = $17;    { Mode Control register index in CRTC  }
  MAP_MASK      = 2;      { Map Mask register index in SC        }

  HORZ_TOTAL         = 0;
  HORZ_DISPLAY_END   = 1;
  START_HORZ_BLANK   = 2;
  END_HORZ_BLANK     = 3;
  START_HORZ_RETRACE = 4;
  END_HORZ_RETRACE   = 5;
  VERT_TOTAL         = 6;
  OVERFLOW           = 7;
  START_VERT_RETRACE = $10;
  END_VERT_RETRACE   = $11;
  VERT_DISPLAY_END   = $12;
  CRTC_OFFSET        = $13;
  START_VERT_BLANK   = $15;
  END_VERT_BLANK     = $16;
  LINE_COMPARE       = $18;

Procedure Set320By200Mode; Assembler;
Asm
  MOV   DX,SC_INDEX
  MOV   AL,MEMORY_MODE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  OR    AL,08h                    { Turn on chain 4 }
  AND   AL,NOT 04h                { Turn on odd/even }
  OUT   DX,AL

  MOV   DX,GC_INDEX
  MOV   AL,GRAPHICS_MODE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  OR    AL,10h                    { Turn on odd/even }
  OUT   DX,AL
  DEC   DX

  MOV   AL,MISCELLANEOUS
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  OR    AL,02h                    { Turn on chain }
  OUT   DX,AL

  { Now clear the whole screen.  Do this before we switch the CRTC out }
  { of mode 13h, so we don't see garbage on the screen when we make    }
  { the switch.                                                        }

  MOV   DX,SC_INDEX               { Enable writes to all planes, so  }
  MOV   AX,0F00h + MAP_MASK       {  we can clear 4 pixels at a time }
  OUT   DX,AX
  MOV   AX,VGA_SEGMENT
  MOV   ES,AX
  SUB   DI,DI
  MOV   AX,DI
  MOV   CX,8000h                  { # of words in 64k }
  CLD
  REP   STOSW

  MOV   DX,CRTC_INDEX
  MOV   AL,MAX_SCAN_LINE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  MOV   BL,AL
  AND   BL,0E0h
  SHL   AL,1
  AND   AL,1Fh
  OR    AL,1                      { Set maximum scan line }
  OR    AL,BL
  OUT   DX,AL
  DEC   DX

  MOV   AL,UNDERLINE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  OR    AL,40h                    { Turn on doubleword }
  OUT   DX,AL
  DEC   DX

  MOV   AL,MODE_CONTROL
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  AND   AL,NOT 40h
  OUT   DX,AL
End; { Set320By200Mode }


Procedure Set320By400Mode; Assembler;
Asm

  { Change CPU addressing of video memory to linear (not odd/even,     }
  { chain, or chain 4), to allow us to access all 256K of display      }
  { memory.  When this is done, VGA memory will look just like memory  }
  { in modes 10h and 12h, except that each byte of display memory will }
  { control one 256-color pixel, with 4 adjacent pixels at any given   }
  { address, one pixel per plane.                                      }

  MOV   DX,SC_INDEX
  MOV   AL,MEMORY_MODE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  AND   AL,NOT 08h                { Turn off chain 4 }
  OR    AL,04h                    { Turn off odd/even }
  OUT   DX,AL

  MOV   DX,GC_INDEX
  MOV   AL,GRAPHICS_MODE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  AND   AL,NOT 10h                { Turn off odd/even }
  OUT   DX,AL
  DEC   DX

  MOV   AL,MISCELLANEOUS
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  AND   AL,NOT 02h                { Turn off chain }
  OUT   DX,AL

  { Now clear the whole screen.  Do this before we switch the CRTC out }
  { of mode 13h, so we don't see garbage on the screen when we make    }
  { the switch.                                                        }

  MOV   DX,SC_INDEX               { Enable writes to all planes, so  }
  MOV   AX,0F00h + MAP_MASK       {  we can clear 4 pixels at a time }
  OUT   DX,AX
  MOV   AX,VGA_SEGMENT
  MOV   ES,AX
  SUB   DI,DI
  MOV   AX,DI
  MOV   CX,8000h                  { # of words in 64k }
  CLD
  REP   STOSW

  { Tweak the mode to 320x400 256-color mode by not scanning each line }
  { twice.                                                             }

  MOV   DX,CRTC_INDEX
  MOV   AL,MAX_SCAN_LINE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  MOV   BL,AL
  AND   BL,0E0h                     { Save high three bits }
  SHR   AL,1
  AND   AL,0Fh
  OR    AL,BL
{  AND   AL,NOT 1Fh}                { Set maximum scan line = 0 }
  OUT   DX,AL
  DEC   DX

  { Change CRTC scanning from doubleword mode to byte mode, allowing }
  { the CRTC to scan more than 64K of video data.                    }

  MOV   AL,UNDERLINE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  AND   AL,NOT 40h                { Turn off doubleword }
  OUT   DX,AL
  DEC   DX

  MOV   AL,MODE_CONTROL
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  OR    AL,40h                    { Turn on the byte mode bit, so memory   }
  OUT   DX,AL                     {  is scanned for video data in a purely }
                                  {  linear way, just as in modes 10h and  }
                                  {  12h                                   }
End; { Set320By400Mode }


Procedure UnprotectCRTC; Assembler;
Asm

  { Un-protect the CRTC registers }

  MOV   DX,CRTC_INDEX
  MOV   AL,END_VERT_RETRACE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  AND   AL,7Fh
  OUT   DX,AL
  DEC   DX
  MOV   AL,END_HORZ_BLANK
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  OR    AL,80h
  OUT   DX,AL
End; { UnprotectCRTC }


Procedure ProtectCRTC; Assembler;
Asm

  { Re-protect the CRTC registers }

  MOV   DX,CRTC_INDEX
  MOV   AL,END_HORZ_BLANK
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  AND   AL,7Fh
  OUT   DX,AL
  DEC   DX
  MOV   AL,END_VERT_RETRACE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  OR    AL,80h
  OUT   DX,AL
End; { ProtectCRTC }


Procedure GetModeDValues;
Begin
  Go_Mode($D);
  UnprotectCRTC;
  Asm
    MOV   DX,CRTC_INDEX

    MOV   AL,0
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR ModeD[HORZ_TOTAL],AL
    DEC   DX

    MOV   AL,1
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR ModeD[HORZ_DISPLAY_END],AL
    DEC   DX

    MOV   AL,2
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR ModeD[START_HORZ_BLANK],AL
    DEC   DX

    MOV   AL,3
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR ModeD[END_HORZ_BLANK],AL
    DEC   DX

    MOV   AL,4
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR ModeD[START_HORZ_RETRACE],AL
    DEC   DX

    MOV   AL,5
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR ModeD[END_HORZ_RETRACE],AL
    DEC   DX
  End; { Asm }
  ProtectCRTC;
  TextMode(C80);
End; { GetModeDValues }


Procedure Set160ColsB;
Begin
  UnprotectCRTC;
  Asm

    { Change to 160 columns by changing the horizontal registers }
{
    MOV   DX,SC_INDEX

    MOV   AL,1
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    OR    AL,8
    OUT   DX,AL
}
    MOV   DX,CRTC_INDEX

    MOV   AL,HORZ_TOTAL
    MOV   AH,BYTE PTR ModeD[HORZ_TOTAL]
    OUT   DX,AX

    MOV   AL,HORZ_DISPLAY_END
    MOV   AH,BYTE PTR ModeD[HORZ_DISPLAY_END]
    OUT   DX,AX

    MOV   AL,START_HORZ_BLANK
    MOV   AH,BYTE PTR ModeD[START_HORZ_BLANK]
    OUT   DX,AX

    MOV   AL,END_HORZ_BLANK
    MOV   AH,BYTE PTR ModeD[END_HORZ_BLANK]
    OUT   DX,AX

    MOV   AL,START_HORZ_RETRACE
    MOV   AH,BYTE PTR ModeD[START_HORZ_RETRACE]
    OUT   DX,AX

    MOV   AL,END_HORZ_RETRACE
    MOV   AH,BYTE PTR ModeD[END_HORZ_RETRACE]
    OUT   DX,AX

    MOV   AL,CRTC_OFFSET
    MOV   AH,14h
    OUT   DX,AX

    { If 320x200x256 was tweaked so that a nonstandard crystal is being }
    { used, move down to the 480-scan-line crystal.  This is necessary  }
    { because dividing the horizontal characters by 2 might cause the   }
    { video card to drive the monitor too fast                          }

    MOV   DX,03CCh
    IN    AL,DX
    MOV   BL,AL
    SHR   BL,2
    AND   BL,3
    CMP   BL,1
    JBE   @NoChange
    AND   AL,0F3h
    OR    AL,4
    MOV   DX,03C2h
    OUT   DX,AL
@NoChange:
  End; { Asm }
  ProtectCRTC;
End; { Set160ColsB }

Procedure Set160ColsA;
Begin
  UnprotectCRTC;
  Asm

    { Change to 160 columns by changing the horizontal registers }

    MOV   DX,03DAh
    IN    AL,DX
    MOV   DX,03C0h
    MOV   AL,30h
    OUT   DX,AL
    MOV   AL,41h
    OUT   DX,AL

    MOV   DX,GC_INDEX
    MOV   AL,05h
    OUT   DX,AL
    INC   DX
    MOV   AL,40h
    OUT   DX,AL
    DEC   DX

    MOV   DX,CRTC_INDEX
    MOV   AL,14h
    OUT   DX,AL
    INC   DX
    MOV   AL,40h
    OUT   DX,AL
    DEC   DX

    MOV   DX,SC_INDEX
    MOV   AL,04h
    OUT   DX,AL
    INC   DX
    MOV   AL,0Eh
    OUT   DX,AL
    DEC   DX

    CLI
    MOV   DX,03DAh
    IN    AL,DX
    MOV   DX,03C0h
    MOV   CX,10h
    SUB   BX,BX
@L1A:
    MOV   AL,BL
    OUT   DX,AL
    MOV   AL,BH
    OUT   DX,AL
    ADD   BX,0101h
    LOOP  @L1A
    MOV   AL,20h
    OUT   DX,AL
    STI
  End; { Asm }
  ProtectCRTC;
End; { Set160ColsA }

(*
Procedure Set320Cols;
Begin
  UnprotectCRTC;
  Asm

    { Change to 320 columns by changing the horizontal registers }

    MOV   DX,CRTC_INDEX

    MOV   AL,HORZ_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,5Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,HORZ_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,4Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_HORZ_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,50h
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_HORZ_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,82h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_HORZ_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,24h
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_HORZ_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,80h
    OUT   DX,AL
    DEC   DX

    MOV   AL,CRTC_OFFSET
    OUT   DX,AL
    INC   DX
    MOV   AL,28h
    OUT   DX,AL
    DEC   DX
  End; { Asm }
  ProtectCRTC;
End; { Set320Cols }
*)
Procedure SetRows(Rows: Word);
{ Variation on the SetRows procedure in unit PROTMENU; this method is more }
{ flexible and robust than the previous version.                           }
Var
  VT,VRS,VRE,VDE,VBS,VBE,LC                 : Word;
  _VT,_OV,_MSL,_VRS,_VRE,_VDE,_VBS,_VBE,_LC : Word;
  OriginalRows                              : Word;
  MiscReg                                   : Byte;
  Multiplier                                : Word;

Begin

  { Save the number of rows that we're told to do, since Rows can be }
  { recalculated.                                                    }

  OriginalRows := Rows;

  { Important to initialize these since they are words }

  _VT  := 0;
  _OV  := 0;
  _MSL := 0;
  _VRS := 0;
  _VRE := 0;
  _VDE := 0;
  _VBS := 0;
  _VBE := 0;
  _LC  := 0;

  UnprotectCRTC;

  { Read the VGA Miscellaneous Register }

  Asm
    MOV   DX,MISC_INPUT
    IN    AL,DX
    MOV   BYTE PTR MiscReg,AL
  End; { Asm }

  { Get the current CRTC register values }

  Asm
    MOV   DX,CRTC_INDEX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    DEC   DX
    MOV   BYTE PTR _VT,AL

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    DEC   DX
    MOV   BYTE PTR _OV,AL

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    DEC   DX
    MOV   BYTE PTR _MSL,AL

    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    DEC   DX
    MOV   BYTE PTR _VRS,AL

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    DEC   DX
    MOV   BYTE PTR _VRE,AL

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    DEC   DX
    MOV   BYTE PTR _VDE,AL

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    DEC   DX
    MOV   BYTE PTR _VBS,AL

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    DEC   DX
    MOV   BYTE PTR _VBE,AL

    MOV   AL,LINE_COMPARE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    DEC   DX
    MOV   BYTE PTR _LC,AL
  End; { Asm }

  { Retrieve the full values }

  VT  := ((_OV And $20) Shr 4) + (_OV And 1);
  VT  := (VT Shl 8) + _VT;

  VRS := ((_OV And $80) Shr 6) + ((_OV And 4) Shr 2);
  VRS := (VRS Shl 8) + _VRS;

  VRE := (VRS And $FFF0) + (_VRE And $F);
  If VRE < VRS Then Inc(VRE,$10);

  VDE := ((_OV And $40) Shr 5) + ((_OV And 2) Shr 1);
  VDE := (VDE Shl 8) + _VDE;

  VBS := ((_MSL And $20) Shr 4) + ((_OV And 8) Shr 3);
  VBS := (VBS Shl 8) + _VBS;

  VBE := (VBS And $FF00) + (_VBE And $FF);  { Not really standard VGA... }
  While VBE < VBS Do Inc(VBE,$80);          { Correct if necessary       }

  LC  := ((_MSL And $40) Shr 5) + ((_OV And $10) Shr 4);
  LC  := (LC Shl 8) + _LC;

  { Recalculate the number of rows we want.  This is because we know that  }
  { we are in basic 320x200x256 mode 13h, and some custom ones (like mine) }
  { may actually have more than 200 scan lines (my custom software sets it }
  { to 400 scan lines for a more solid look).                              }

{  Rows := Rows * ((VDE + 1) Div 200);}
  Multiplier := ((_MSL And $1F) + 1);

  { If the 200-to-400 bit is set on the Max Scan Line register, multiply }
  { the number of rows by 2                                              }

  If (_MSL And $80) <> 0 Then Multiplier := Multiplier * 2;

  Rows := Rows * Multiplier;

  { Only do something if the rows actually changed }

  If Rows <> VDE + 1 Then
  Begin

    { Recalculate the values }

    Inc(VT ,Rows - (VDE + 1));
    Inc(VRS,Rows - (VDE + 1));
    Inc(VRE,Rows - (VDE + 1));
    Inc(VBS,Rows - (VDE + 1));
    Inc(VBE,Rows - (VDE + 1));
    Inc(LC ,Rows - (VDE + 1));
    Inc(VDE,Rows - (VDE + 1)); { Must do last }

    { Bounds-checking }

    If VT  > 1023 Then VT  := 1023;
    If VRS > 1023 Then VRS := 1023;
    If VRE > 1023 Then VRE := 1023;
    If VDE > 1023 Then VDE := 1023;
    If VBS > 1023 Then VBS := 1023;
    If VBE > 1023 Then VBE := 1023;
    If LC  > 1023 Then LC  := 1023;

    { Break the new values into the registers }

    _VT  := VT  And $FF;
    _MSL := (_MSL And $9F) + ((LC Shr 3) And $40) + ((VBS Shr 4) And $20);
    _VRS := VRS And $FF;
    _VRE := (_VRE And $F0) + (VRE And $F);
    _VDE := VDE And $FF;
    _VBS := VBS And $FF;
    _VBE := VBE And $FF;             { The VGA standard says that VBE is  }
    _LC  := LC  And $FF;             { only seven bits, but my ATI 3D Pro }
    _OV  := ((VRS Shr 2) And $80) +  { Turbo doesn't handle this properly }
            ((VDE Shr 3) And $40) +  { unless I fill in all 8 bits.  I    }
            ((VT  Shr 4) And $20) +  { figure that cards that follow the  }
            ((LC  Shr 4) And $10) +  { standard properly shouldn't be     }
            ((VBS Shr 5) And $08) +  { bothered by the extra bit...       }
            ((VRS Shr 6) And $04) +
            ((VDE Shr 7) And $02) +
            ((VT  Shr 8) And $01);

(*
  TextMode(C80);
  WriteLn('OriginalRows = ',OriginalRows);
  WriteLn('Multiplier   = ',Multiplier);
  WriteLn('Rows         = ',Rows);
  WriteLn;
  WriteLn('VT           = ',VT);
  WriteLn('VRS          = ',VRS);
  WriteLn('VRE          = ',VRE);
  WriteLn('VBS          = ',VBS);
  WriteLn('VBE          = ',VBE);
  WriteLn('LC           = ',LC);
  WriteLn('VDE          = ',VDE);
  WriteLn;
  WriteLn('_VT          = ',HexByte(_VT));
  WriteLn('_OV          = ',HexByte(_OV));
  WriteLn('_MSL         = ',HexByte(_MSL));
  WriteLn('_VRS         = ',HexByte(_VRS));
  WriteLn('_VRE         = ',HexByte(_VRE));
  WriteLn('_VDE         = ',HexByte(_VDE));
  WriteLn('_VBS         = ',HexByte(_VBS));
  WriteLn('_VBE         = ',HexByte(_VBE));
  WriteLn('_LC          = ',HexByte(_LC));
  ReadKey;
  Asm
    MOV  AX,0Dh
    INT  10h
  End; { Asm }
  Set160ColsA;
  UnprotectCRTC;
*)

    { For some bizarre reason, my new ATI All-In-Wonder 128 won't display }
    { the screen if the total VRS is 512, so force it to 513 in that case }

    If _VRS = 0 Then _VRS := _VRS Or $01;


    { Change to new rows by changing the vertical registers }

    Asm
      MOV   DX,CRTC_INDEX

      MOV   AL,VERT_TOTAL
      MOV   AH,BYTE PTR _VT
      OUT   DX,AX

      MOV   AL,OVERFLOW
      MOV   AH,BYTE PTR _OV
      OUT   DX,AX

      MOV   AL,MAX_SCAN_LINE
      MOV   AH,BYTE PTR _MSL
      OUT   DX,AX

      MOV   AL,START_VERT_RETRACE
      MOV   AH,BYTE PTR _VRS
      OUT   DX,AX

      MOV   AL,END_VERT_RETRACE
      MOV   AH,BYTE PTR _VRE
      OUT   DX,AX

      MOV   AL,VERT_DISPLAY_END
      MOV   AH,BYTE PTR _VDE
      OUT   DX,AX

      MOV   AL,START_VERT_BLANK
      MOV   AH,BYTE PTR _VBS
      OUT   DX,AX

      MOV   AL,END_VERT_BLANK
      MOV   AH,BYTE PTR _VBE
      OUT   DX,AX

      MOV   AL,LINE_COMPARE
      MOV   AH,BYTE PTR _LC
      OUT   DX,AX
    End; { Asm }

    { If the requested number of scan lines is 480 or larger, see if we }
    { have to change the VGA output crystal.  Do this only if the       }
    { current crystal is the basic 400-scan line crystal, so we don't   }
    { mess up customized VGA modes.                                     }

    If (OriginalRows * Multiplier >= 480) And ((MiscReg And $0C) = 0) Then
    Begin
      Asm
        MOV   DX,MISC_OUTPUT
        MOV   AL,BYTE PTR MiscReg
        OR    AL,4
        OUT   DX,AL
      End; { Asm }
    End;
  End;
  ProtectCRTC;
End; { SetRows }

(*
Procedure SetRows(Rows: Word);
Begin
  UnprotectCRTC;
  Asm

    { Change to new rows by changing the vertical registers }

    MOV   BX,WORD PTR Rows
    SUB   BX,200

    MOV   DX,CRTC_INDEX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   CL,AL
    AND   CL,1Fh
    SHL   BX,CL
    DEC   DX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    OUT   DX,AL
    DEC   DX
{
    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    MOV   AL,1Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    MOV   AL,41h
    OUT   DX,AL
    DEC   DX
}
    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   CL,AL
    ADD   CL,BL
    AND   CL,0Fh
    AND   AL,20h
    OR    AL,CL
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    OUT   DX,AL
    DEC   DX
  End; { Asm }
  ProtectCRTC;
End; { SetRows }
*)

Procedure Set160RowsOLD(Rows: Word);
Var
  MSL,OV,VT,SVR,EVR,VDE,SVB,EVB,LC : Word;

Begin
  UnprotectCRTC;
  Asm

    { Change to 160 columns by changing the horizontal registers }

    MOV   DX,SC_INDEX

    MOV   AL,1
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    OR    AL,8
    OUT   DX,AL

    MOV   DX,CRTC_INDEX

    MOV   AL,HORZ_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,2Ah
    OUT   DX,AL
    DEC   DX

    MOV   AL,HORZ_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,27h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_HORZ_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,28h
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_HORZ_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,8Eh
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_HORZ_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,2Ch
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_HORZ_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,8Eh
    OUT   DX,AL
    DEC   DX

    MOV   AL,CRTC_OFFSET
    OUT   DX,AL
    INC   DX
    MOV   AL,14h
    OUT   DX,AL
    DEC   DX

    { Get rows info }

    MOV   DX,CRTC_INDEX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR MSL,AL
    DEC   DX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR VT,AL
    DEC   DX

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR OV,AL
    MOV   BYTE PTR OV[1],AL
    DEC   DX

    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR SVR,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR EVR,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR VDE,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR SVB,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR EVB,AL
    DEC   DX

    MOV   AL,LINE_COMPARE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR LC,AL
    DEC   DX

    { Form 16-bit vertical values }

    MOV   AL,BYTE PTR OV
    MOV   AH,AL
    AND   AX,2001h
    SHR   AH,4
    OR    AL,AH
    MOV   BYTE PTR VT[1],AL

    MOV   AL,BYTE PTR OV
    MOV   AH,AL
    AND   AX,4002h
    SHR   AH,4
    OR    AL,AH
    SHR   AL,1
    MOV   BYTE PTR VDE[1],AL

    MOV   AL,BYTE PTR OV
    MOV   AH,AL
    AND   AX,8004h
    SHR   AH,4
    OR    AL,AH
    SHR   AL,2
    MOV   BYTE PTR SVR[1],AL

    MOV   AL,BYTE PTR OV
    AND   AL,8
    MOV   AH,BYTE PTR MSL
    AND   AH,20h
    SHR   AH,1
    OR    AL,AH
    SHR   AL,3
    MOV   BYTE PTR SVB[1],AL

    MOV   AL,BYTE PTR OV
    AND   AL,10h
    MOV   AH,BYTE PTR MSL
    AND   AH,40h
    SHR   AH,1
    OR    AL,AH
    SHR   AL,4
    MOV   BYTE PTR LC[1],AL

    MOV   AX,WORD PTR SVR
    AND   AX,3F0h
    MOV   BL,BYTE PTR EVR
    AND   BL,0Fh
    OR    AL,BL
    CMP   AX,WORD PTR SVR
    JGE   @L1
    ADD   AX,10h
@L1:
    MOV   WORD PTR EVR,AX

    MOV   AH,BYTE PTR SVB[1]
    MOV   AL,BYTE PTR EVB
    CMP   AX,WORD PTR SVB
    JGE   @L2
    INC   AH
@L2:
    MOV   BYTE PTR EVB[1],AH

    { Get the increment }

    MOV   BX,WORD PTR Rows
    SUB   BX,200
    MOV   CL,BYTE PTR MSL
    AND   CL,1Fh
    SHL   BX,CL

    { Add the increment }

    ADD   WORD PTR VT,BX
    ADD   WORD PTR SVR,BX
    ADD   WORD PTR EVR,BX
    ADD   WORD PTR VDE,BX
    ADD   WORD PTR SVB,BX
    ADD   WORD PTR EVB,BX
    ADD   WORD PTR LC,BX

    { Bounds-checking }

    CMP   WORD PTR LC,3FFh
    JLE   @L3
    MOV   WORD PTR LC,3FFh
@L3:

    { Form the new overflow }

    MOV   AL,BYTE PTR VT[1]
    MOV   AH,AL
    SHL   AH,4
    AND   AX,2001h
    OR    AL,AH

    MOV   BL,BYTE PTR VDE[1]
    MOV   BH,BL
    SHL   BH,4
    AND   BX,2001h
    SHL   BX,1
    OR    AL,BL
    OR    AL,BH

    MOV   BL,BYTE PTR SVR[1]
    MOV   BH,BL
    SHL   BH,4
    AND   BX,2001h
    SHL   BX,2
    OR    AL,BL
    OR    AL,BH

    MOV   BL,BYTE PTR SVB[1]
    AND   BL,1
    SHL   BL,3
    OR    AL,BL

    MOV   BL,BYTE PTR LC[1]
    AND   BL,1
    SHL   BL,4
    OR    AL,BL

    MOV   BYTE PTR OV,AL

    { Form the new max scan line }

    MOV   AL,BYTE PTR MSL
    AND   AL,9Fh

    MOV   BL,BYTE PTR SVB[1]
    AND   BL,2
    SHL   BL,4
    OR    AL,BL

    MOV   BL,BYTE PTR LC[1]
    AND   BL,2
    SHL   BL,5
    OR    AL,BL

    MOV   BYTE PTR MSL,AL

    { Output the new values }

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR MSL
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR VT
    OUT   DX,AL
    DEC   DX

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR OV
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR SVR
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    AND   AL,0F0h
    MOV   AH,BYTE PTR EVR
    AND   AH,0Fh
    OR    AL,AH
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR VDE
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR SVB
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR EVB
    OUT   DX,AL
    DEC   DX

    MOV   AL,LINE_COMPARE
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR LC
    OUT   DX,AL
    DEC   DX
  End; { Asm }
  ProtectCRTC;
{
  TextMode(C80);
  WriteLn('MSL = ',HexWord(MSL));
  WriteLn('OV  = ',HexWord(OV));
  WriteLn('VT  = ',HexWord(VT));
  WriteLn('VDE = ',HexWord(VDE));
  WriteLn('SVB = ',HexWord(SVB));
  WriteLn('EVB = ',HexWord(EVB));
  WriteLn('SVR = ',HexWord(SVR));
  WriteLn('EVR = ',HexWord(EVR));
  WriteLn('LC  = ',HexWord(LC));
  ReadKey;}
End; { Set160RowsOLD }

Procedure Set160RowsA(Rows: Word);
Var
  MSL,OV,VT,SVR,EVR,VDE,SVB,EVB,LC : Word;

Begin
  UnprotectCRTC;
  Asm

    { Change to 160 columns by changing the horizontal registers }

    MOV   DX,03DAh
    IN    AL,DX
    MOV   DX,03C0h
    MOV   AL,30h
    OUT   DX,AL
    MOV   AL,41h
    OUT   DX,AL

    MOV   DX,GC_INDEX
    MOV   AL,05h
    OUT   DX,AL
    INC   DX
    MOV   AL,40h
    OUT   DX,AL
    DEC   DX

    MOV   DX,CRTC_INDEX
    MOV   AL,14h
    OUT   DX,AL
    INC   DX
    MOV   AL,40h
    OUT   DX,AL
    DEC   DX

    MOV   DX,SC_INDEX
    MOV   AL,04h
    OUT   DX,AL
    INC   DX
    MOV   AL,0Eh
    OUT   DX,AL
    DEC   DX

    CLI
    MOV   DX,03DAh
    IN    AL,DX
    MOV   DX,03C0h
    MOV   CX,10h
    SUB   BX,BX
@L1A:
    MOV   AL,BL
    OUT   DX,AL
    MOV   AL,BH
    OUT   DX,AL
    ADD   BX,0101h
    LOOP  @L1A
    MOV   AL,20h
    OUT   DX,AL
    STI

    { Get rows info }

    MOV   DX,CRTC_INDEX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR MSL,AL
    DEC   DX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR VT,AL
    DEC   DX

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR OV,AL
    MOV   BYTE PTR OV[1],AL
    DEC   DX

    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR SVR,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR EVR,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR VDE,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR SVB,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR EVB,AL
    DEC   DX

    MOV   AL,LINE_COMPARE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR LC,AL
    DEC   DX

    { Form 16-bit vertical values }

    MOV   AL,BYTE PTR OV
    MOV   AH,AL
    AND   AX,2001h
    SHR   AH,4
    OR    AL,AH
    MOV   BYTE PTR VT[1],AL

    MOV   AL,BYTE PTR OV
    MOV   AH,AL
    AND   AX,4002h
    SHR   AH,4
    OR    AL,AH
    SHR   AL,1
    MOV   BYTE PTR VDE[1],AL

    MOV   AL,BYTE PTR OV
    MOV   AH,AL
    AND   AX,8004h
    SHR   AH,4
    OR    AL,AH
    SHR   AL,2
    MOV   BYTE PTR SVR[1],AL

    MOV   AL,BYTE PTR OV
    AND   AL,8
    MOV   AH,BYTE PTR MSL
    AND   AH,20h
    SHR   AH,1
    OR    AL,AH
    SHR   AL,3
    MOV   BYTE PTR SVB[1],AL

    MOV   AL,BYTE PTR OV
    AND   AL,10h
    MOV   AH,BYTE PTR MSL
    AND   AH,40h
    SHR   AH,1
    OR    AL,AH
    SHR   AL,4
    MOV   BYTE PTR LC[1],AL

    MOV   AX,WORD PTR SVR
    AND   AX,3F0h
    MOV   BL,BYTE PTR EVR
    AND   BL,0Fh
    OR    AL,BL
    CMP   AX,WORD PTR SVR
    JGE   @L1
    ADD   AX,10h
@L1:
    MOV   WORD PTR EVR,AX

    MOV   AH,BYTE PTR SVB[1]
    MOV   AL,BYTE PTR EVB
    CMP   AX,WORD PTR SVB
    JGE   @L2
    INC   AH
@L2:
    MOV   BYTE PTR EVB[1],AH

    { Get the increment }

    MOV   BX,WORD PTR Rows
    SUB   BX,200
    MOV   CL,BYTE PTR MSL
    AND   CL,1Fh
    SHL   BX,CL

    { Add the increment }

    ADD   WORD PTR VT,BX
    ADD   WORD PTR SVR,BX
    ADD   WORD PTR EVR,BX
    ADD   WORD PTR VDE,BX
    ADD   WORD PTR SVB,BX
    ADD   WORD PTR EVB,BX
    ADD   WORD PTR LC,BX

    { Bounds-checking }

    CMP   WORD PTR LC,3FFh
    JLE   @L3
    MOV   WORD PTR LC,3FFh
@L3:

    { Form the new overflow }

    MOV   AL,BYTE PTR VT[1]
    MOV   AH,AL
    SHL   AH,4
    AND   AX,2001h
    OR    AL,AH

    MOV   BL,BYTE PTR VDE[1]
    MOV   BH,BL
    SHL   BH,4
    AND   BX,2001h
    SHL   BX,1
    OR    AL,BL
    OR    AL,BH

    MOV   BL,BYTE PTR SVR[1]
    MOV   BH,BL
    SHL   BH,4
    AND   BX,2001h
    SHL   BX,2
    OR    AL,BL
    OR    AL,BH

    MOV   BL,BYTE PTR SVB[1]
    AND   BL,1
    SHL   BL,3
    OR    AL,BL

    MOV   BL,BYTE PTR LC[1]
    AND   BL,1
    SHL   BL,4
    OR    AL,BL

    MOV   BYTE PTR OV,AL

    { Form the new max scan line }

    MOV   AL,BYTE PTR MSL
    AND   AL,9Fh

    MOV   BL,BYTE PTR SVB[1]
    AND   BL,2
    SHL   BL,4
    OR    AL,BL

    MOV   BL,BYTE PTR LC[1]
    AND   BL,2
    SHL   BL,5
    OR    AL,BL

    MOV   BYTE PTR MSL,AL

    { Output the new values }

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR MSL
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR VT
    OUT   DX,AL
    DEC   DX

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR OV
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR SVR
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    AND   AL,0F0h
    MOV   AH,BYTE PTR EVR
    AND   AH,0Fh
    OR    AL,AH
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR VDE
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR SVB
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR EVB
    OUT   DX,AL
    DEC   DX

    MOV   AL,LINE_COMPARE
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR LC
    OUT   DX,AL
    DEC   DX
  End; { Asm }
  ProtectCRTC;
{
  TextMode(C80);
  WriteLn('MSL = ',HexWord(MSL));
  WriteLn('OV  = ',HexWord(OV));
  WriteLn('VT  = ',HexWord(VT));
  WriteLn('VDE = ',HexWord(VDE));
  WriteLn('SVB = ',HexWord(SVB));
  WriteLn('EVB = ',HexWord(EVB));
  WriteLn('SVR = ',HexWord(SVR));
  WriteLn('EVR = ',HexWord(EVR));
  WriteLn('LC  = ',HexWord(LC));
  ReadKey;}
End; { Set160RowsA }


Procedure Set160Rows1(Rows: Word);
Begin
  UnprotectCRTC;
  Asm

    { Change to 160 columns by changing the horizontal registers }

    MOV   DX,SC_INDEX

    MOV   AL,1
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    OR    AL,8
    OUT   DX,AL

    MOV   DX,CRTC_INDEX

    MOV   AL,HORZ_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,2Ah
    OUT   DX,AL
    DEC   DX

    MOV   AL,HORZ_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,27h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_HORZ_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,28h
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_HORZ_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,8Eh
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_HORZ_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,2Ch
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_HORZ_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,8Eh
    OUT   DX,AL
    DEC   DX

    MOV   AL,CRTC_OFFSET
    OUT   DX,AL
    INC   DX
    MOV   AL,14h
    OUT   DX,AL
    DEC   DX

    { Change to new rows by changing the vertical registers }

    MOV   BX,WORD PTR Rows
    SUB   BX,200

    MOV   DX,CRTC_INDEX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   CL,AL
    AND   CL,1Fh
    SHL   BL,CL
    DEC   DX

    MOV   BH,1Fh

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    JNC   @L1
    MOV   BH,02Eh
@L1:
    OUT   DX,AL
    DEC   DX

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    MOV   AL,BH
{    OUT   DX,AL}
    DEC   DX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
{    MOV   CL,AL
    AND   CL,1Fh
    SHL   BX,CL}
    CMP   BH,1Fh
    JE    @L2
    OR    AL,40h
@L2:
    OUT   DX,AL
    DEC   DX
{
    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    MOV   AL,1Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    MOV   AL,41h
    OUT   DX,AL
    DEC   DX
}
    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   CL,AL
    ADD   CL,BL
    AND   CL,0Fh
    AND   AL,20h
    OR    AL,CL
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    OUT   DX,AL
    DEC   DX
  End; { Asm }
  ProtectCRTC;
End; { Set160Rows1 }


Procedure Set200Rows;
Begin
  UnprotectCRTC;
  Asm

    { Change to 205 rows by changing the vertical registers }

    MOV   DX,CRTC_INDEX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,0BFh
    OUT   DX,AL
    DEC   DX

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    MOV   AL,1Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    MOV   AL,41h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,09Ch
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    AND   AL,2Eh
    OR    AL,0Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,08Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,96h
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,0B9h
    OUT   DX,AL
    DEC   DX
  End; { Asm }
  ProtectCRTC;
End; { Set200Rows }


Procedure Set205Rows;
Begin
  UnprotectCRTC;
  Asm

    { Change to 205 rows by changing the vertical registers }

    MOV   DX,CRTC_INDEX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,0C7h
    OUT   DX,AL
    DEC   DX

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    MOV   AL,1Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    MOV   AL,41h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,0A4h
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    AND   AL,20h
    OR    AL,07h
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,097h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,09Eh
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,0C1h
    OUT   DX,AL
    DEC   DX
  End; { Asm }
  ProtectCRTC;
End; { Set205Rows }


Procedure Set210Rows;
Begin
  UnprotectCRTC;
  Asm

    { Change to 210 rows by changing the vertical registers }

    MOV   DX,CRTC_INDEX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,0D3h
    OUT   DX,AL
    DEC   DX

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    MOV   AL,1Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    MOV   AL,41h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,0B0h
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    AND   AL,20h
    OR    AL,03h
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,0A3h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,0AAh
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,0CDh
    OUT   DX,AL
    DEC   DX
  End; { Asm }
  ProtectCRTC;
End; { Set210Rows }


Procedure Set215Rows;
Begin
  UnprotectCRTC;
  Asm

    { Change to 215 rows by changing the vertical registers }

    MOV   DX,CRTC_INDEX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,0D3h
    OUT   DX,AL
    DEC   DX

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    MOV   AL,1Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    MOV   AL,41h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,0D0h
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    AND   AL,20h
    OR    AL,03h
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,0A3h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,0AAh
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,0BDh
    OUT   DX,AL
    DEC   DX
  End; { Asm }
  ProtectCRTC;
End; { Set215Rows }


Procedure Set240Rows;
Begin
  UnprotectCRTC;
  Asm

    { Change to 240 rows by changing the vertical registers }

    MOV   DX,CRTC_INDEX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,005h
    OUT   DX,AL
    DEC   DX

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    MOV   AL,3Eh
    OUT   DX,AL
    DEC   DX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    MOV   AL,41h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,0E2h
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    AND   AL,20h
    OR    AL,05h
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,0D5h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,0DCh
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,0FFh
    OUT   DX,AL
    DEC   DX

    MOV   DX,MISC_OUTPUT
    MOV   AL,0E7h
    OUT   DX,AL
  End; { Asm }
  ProtectCRTC;
End; { Set240Rows }


Procedure PutChar(X,Y: Word; C: Char; Color: Word); Assembler;
Asm
  TEST  BYTE PTR HiRes,0FFh
  JZ    @Normal
  MOV   AX,WORD PTR Y
  SHL   AX,4
  MOV   DI,AX
  SHL   DI,2
  ADD   DI,AX
  MOV   AX,WORD PTR X
  SHR   AX,2
  ADD   DI,AX
  MOV   AH,11h
  MOV   CX,WORD PTR X
  AND   CX,3
  ROL   AH,CL
  MOV   AL,MAP_MASK
  MOV   DX,SC_INDEX

  PUSH  DS
  LDS   SI,DWORD PTR FontPtr
  MOV   BL,BYTE PTR C
  SUB   BH,BH
  SHL   BX,3
  ADD   SI,BX
  MOV   BX,0A000h
  MOV   ES,BX
  MOV   CX,8
  MOV   BX,WORD PTR Color
@Loop1:
  OUT   DX,AX

  TEST  BYTE PTR [SI],80h
  JNZ   @On0
  MOV   BYTE PTR [ES:DI],BH
  JMP   @Do4
@On0:
  MOV   BYTE PTR [ES:DI],BL
@Do4:
  TEST  BYTE PTR [SI],8
  JNZ   @On4
  MOV   BYTE PTR [ES:DI + 1],BH
  JMP   @Do1
@On4:
  MOV   BYTE PTR [ES:DI + 1],BL
@Do1:

  ROL   AH,1
  ADC   DI,0
  OUT   DX,AX
  TEST  BYTE PTR [SI],40h
  JNZ   @On1
  MOV   BYTE PTR [ES:DI],BH
  JMP   @Do5
@On1:
  MOV   BYTE PTR [ES:DI],BL
@Do5:
  TEST  BYTE PTR [SI],4
  JNZ   @On5
  MOV   BYTE PTR [ES:DI + 1],BH
  JMP   @Do2
@On5:
  MOV   BYTE PTR [ES:DI + 1],BL
@Do2:

  ROL   AH,1
  ADC   DI,0
  OUT   DX,AX
  TEST  BYTE PTR [SI],20h
  JNZ   @On2
  MOV   BYTE PTR [ES:DI],BH
  JMP   @Do6
@On2:
  MOV   BYTE PTR [ES:DI],BL
@Do6:
  TEST  BYTE PTR [SI],2
  JNZ   @On6
  MOV   BYTE PTR [ES:DI + 1],BH
  JMP   @Do3
@On6:
  MOV   BYTE PTR [ES:DI + 1],BL
@Do3:

  ROL   AH,1
  ADC   DI,0
  OUT   DX,AX
  TEST  BYTE PTR [SI],10h
  JNZ   @On3
  MOV   BYTE PTR [ES:DI],BH
  JMP   @Do7
@On3:
  MOV   BYTE PTR [ES:DI],BL
@Do7:
  TEST  BYTE PTR [SI],1
  JNZ   @On7
  MOV   BYTE PTR [ES:DI + 1],BH
  JMP   @Done
@On7:
  MOV   BYTE PTR [ES:DI + 1],BL
@Done:
  ROL   AH,1
  TEST  BYTE PTR X,3
  JZ    @NoDec
  DEC   DI
@NoDec:
  ADD   DI,80
  INC   SI
  DEC   CX
  JNZ   @Loop1

  POP   DS
  JMP   @L3

@Normal:
  MOV   AX,WORD PTR Y
  SUB   BX,BX
  MOV   BH,AL
  SHL   AX,6
  ADD   BX,AX
  MOV   DI,BX
  ADD   DI,WORD PTR X
  PUSH  DS
  LDS   SI,DWORD PTR FontPtr
  MOV   AL,BYTE PTR C
  SUB   AH,AH
  SHL   AX,3
  ADD   SI,AX
  MOV   AX,0A000h
  MOV   ES,AX
  MOV   AL,8
  ADD   DI,7
  MOV   DX,WORD PTR Color
@Loop:
  MOV   BH,BYTE PTR [SI]
  MOV   CX,8
  MOV   BL,1
@L1:
  TEST  BH,BL
  JZ    @L2
  MOV   BYTE PTR [ES:DI],DL
  DEC   DI
  ADD   BL,BL
  LOOP  @L1
  ADD   DI,328
  INC   SI
  DEC   AL
  JNZ   @Loop
  POP   DS
  JMP   @L3
@L2:
  MOV   BYTE PTR [ES:DI],DH
  DEC   DI
  ADD   BL,BL
  LOOP  @L1
  ADD   DI,328
  INC   SI
  DEC   AL
  JNZ   @Loop
  POP   DS
@L3:
End; { PutChar }


Procedure WriteOut(X,Y: Word; St: String; Color: Word);
Var I: Byte;
Begin
  If St = '' Then Exit;
  For I := 0 To Length(St) - 1 Do PutChar(X + (I * 8),Y,St[I + 1],Color);
End; { WriteOut }


Procedure PutSmChar(X,Y: Word; C: Char; Color: Word); Assembler;
Asm
  TEST  BYTE PTR HiRes,0FFh
  JZ    @Normal
  MOV   AX,WORD PTR Y
  SHL   AX,4
  MOV   DI,AX
  SHL   DI,2
  ADD   DI,AX
  MOV   AX,WORD PTR X
  SHR   AX,2
  ADD   DI,AX
  MOV   AH,11h
  MOV   CX,WORD PTR X
  AND   CX,3
  ROL   AH,CL
  MOV   AL,MAP_MASK
  MOV   DX,SC_INDEX

  PUSH  DS
  LDS   SI,DWORD PTR FontSmPtr
  MOV   BL,BYTE PTR C
  SUB   BH,BH
  SHL   BX,3
  ADD   SI,BX
  MOV   BX,0A000h
  MOV   ES,BX
  MOV   CX,8
  MOV   BX,WORD PTR Color
@Loop1:
  OUT   DX,AX

  TEST  BYTE PTR [SI],80h
  JNZ   @On0
  MOV   BYTE PTR [ES:DI],BH
  JMP   @Do4
@On0:
  MOV   BYTE PTR [ES:DI],BL
@Do4:
  TEST  BYTE PTR [SI],8
  JNZ   @On4
  MOV   BYTE PTR [ES:DI + 1],BH
  JMP   @Do1
@On4:
  MOV   BYTE PTR [ES:DI + 1],BL
@Do1:

  ROL   AH,1
  ADC   DI,0
  OUT   DX,AX
  TEST  BYTE PTR [SI],40h
  JNZ   @On1
  MOV   BYTE PTR [ES:DI],BH
  JMP   @Do5
@On1:
  MOV   BYTE PTR [ES:DI],BL
@Do5:
  TEST  BYTE PTR [SI],4
  JNZ   @On5
  MOV   BYTE PTR [ES:DI + 1],BH
  JMP   @Do2
@On5:
  MOV   BYTE PTR [ES:DI + 1],BL
@Do2:

  ROL   AH,1
  ADC   DI,0
  OUT   DX,AX
  TEST  BYTE PTR [SI],20h
  JNZ   @On2
  MOV   BYTE PTR [ES:DI],BH
  JMP   @Do3
@On2:
  MOV   BYTE PTR [ES:DI],BL
@Do3:
  ROL   AH,1
  ADC   DI,0
  OUT   DX,AX
  TEST  BYTE PTR [SI],10h
  JNZ   @On3
  MOV   BYTE PTR [ES:DI],BH
  JMP   @Done
@On3:
  MOV   BYTE PTR [ES:DI],BL
@Done:
  ROL   AH,1
  TEST  BYTE PTR X,3
  JZ    @NoDec
  DEC   DI
@NoDec:
  ADD   DI,80
  INC   SI
  DEC   CX
  JNZ   @Loop1

  POP   DS
  JMP   @L3

@Normal:
  MOV   AX,WORD PTR Y
  SUB   BX,BX
  MOV   BH,AL
  SHL   AX,6
  ADD   BX,AX
  MOV   DI,BX
  ADD   DI,WORD PTR X
  PUSH  DS
  LDS   SI,DWORD PTR FontSmPtr
  MOV   AL,BYTE PTR C
  SUB   AH,AH
  SHL   AX,3
  ADD   SI,AX
  MOV   AX,0A000h
  MOV   ES,AX
  MOV   AL,8
  ADD   DI,5{7}
  MOV   DX,WORD PTR Color
@Loop:
  MOV   BH,BYTE PTR [SI]
  MOV   CX,6
  MOV   BL,4
@L1:
  TEST  BH,BL
  JZ    @L2
  MOV   BYTE PTR [ES:DI],DL
  DEC   DI
  ADD   BL,BL
  LOOP  @L1
  ADD   DI,326
  INC   SI
  DEC   AL
  JNZ   @Loop
  POP   DS
  JMP   @L3
@L2:
  MOV   BYTE PTR [ES:DI],DH
  DEC   DI
  ADD   BL,BL
  LOOP  @L1
  ADD   DI,326
  INC   SI
  DEC   AL
  JNZ   @Loop
  POP   DS
@L3:
End; { PutSmChar }


Procedure WriteSmOut(X,Y: Word; St: String; Color: Word);
Var I: Byte;
Begin
  If St = '' Then Exit;
  For I := 0 To Length(St) - 1 Do PutSmChar(X + (I * 6),Y,St[I + 1],Color);
End; { WriteSmOut }


Procedure Swap(Var A,B: Word);
Var C: Word;
Begin
  C := A;
  A := B;
  B := C;
End; { Swap }


Procedure SwapInt(Var A,B: Integer);
Var C: Integer;
Begin
  C := A;
  A := B;
  B := C;
End; { SwapInt }


Function __MakeWin(Var W: _WindowPtr; X1,Y1,X2,Y2: Word; Fill: Byte): Boolean;
Begin
  If W = Nil Then New(W);
  If X2 < X1 Then Swap(X1,X2);
  If Y2 < Y1 Then Swap(Y1,Y2);
  W^._X1        := X1;
  W^._Y1        := Y1;
  W^._X2        := X2;
  W^._Y2        := Y2;
  W^._Size      := (Y2 - Y1 + 1) * (X2 - X1 + 1);
  W^._Back      := Nil;
  W^._Active    := False;
  W^._FillColor := Fill;
  __MakeWin := True;
End; { __MakeWin }


Function __DispWin(Var W: _WindowPtr): Boolean;
Var
  I,J : Word;
  M   : Boolean;
  P   : Pointer;
  X,Y : Word;

Begin
  If W = Nil Then                           { __MakeWin has not been called }
  Begin
    __DispWin := False;
    Exit;
  End;
  W^._Back := Nil;
  If MaxAvail >= W^._Size Then
  Begin
    GetMem(W^._Back,W^._Size);
    I := Seg(W^._Back^);
    J := Ofs(W^._Back^);
    If J > $F Then
    Begin
      Inc(I,J Shr 4);
      J := J And $F;
    End;
    P          := Ptr(I,J);
    W^._Active := True;
    J := W^._X2 - W^._X1 + 1;
{    M := MouseVisible;}
{    If M Then ToggleMouseVisibility;}
    For I := 0 To W^._Y2 - W^._Y1 Do
    Begin
      Move(Mem[$A000:(I + W^._Y1) * 320 + W^._X1],
           Mem[Seg(P^):Ofs(P^) + I * J],J);
      FillChar(Mem[$A000:(I + W^._Y1) * 320 + W^._X1],
               J,W^._FillColor);
    End; { For I }
{    If M Then ToggleMouseVisibility;}
  End;
  If _WindowList = Nil Then
  Begin
    New(_WindowList);
    _WindowList^._Prev   := Nil;
    _WindowList^._Next   := Nil;
    _WindowList^._Window := W;
  End
  Else
  Begin
    _ListWork := _WindowList;
    While _ListWork^._Next <> Nil Do _ListWork := _ListWork^._Next;
    New(_ListWork^._Next);
    _ListWork^._Next^._Prev := _ListWork;
    _ListWork               := _ListWork^._Next;
    _ListWork^._Next        := Nil;
    _ListWork^._Window      := W;
  End;
  __DispWin := True;
End; { __DispWin }


Function __RemWin: Boolean;
Var
  I,J : Word;
  W   : _WindowPtr;
  M   : Boolean;

Begin
  If _WindowList = Nil Then
  Begin
    __RemWin := False;
    Exit;
  End;
  _ListWork := _WindowList;
  While _ListWork^._Next <> Nil Do _ListWork := _ListWork^._Next;
  W := _ListWork^._Window;
  W^._Active := False;
  If W^._Back <> Nil Then
  Begin
    J := W^._X2 - W^._X1 + 1;
{    M := MouseVisible;}
{    If M Then ToggleMouseVisibility;}
    For I := 0 To W^._Y2 - W^._Y1 Do
    Begin
      Move(Mem[Seg(W^._Back^):Ofs(W^._Back^) + I * J],
           Mem[$A000:(I + W^._Y1) * 320 + W^._X1],J);
    End; { For I }
{    If M Then ToggleMouseVisibility;}
    FreeMem(W^._Back,W^._Size);
    W^._Back := Nil;
  End;
  If _ListWork^._Prev <> Nil Then
  Begin
    _ListWork := _ListWork^._Prev;
    Dispose(_ListWork^._Next);
    _ListWork^._Next := Nil;
  End
  Else
  Begin
    Dispose(_ListWork);
    _WindowList := Nil;
  End;
  __RemWin := True;
End; { __RemWin }


Procedure Box(X1,Y1,X2,Y2: Integer; Color: Byte);
Begin
  If HiRes Then RectangleX(X1,Y1,X2,Y2,0,Color)
  Else
  Begin
    Line(X1,Y1,X2,Y1,Color);
    Line(X2,Y1,X2,Y2,Color);
    Line(X2,Y2,X1,Y2,Color);
    Line(X1,Y2,X1,Y1,Color);
  End;
End; { Box }


Procedure FBox(X1,Y1,X2,Y2: Integer; Color: Byte);
Var Y,Addr,Len: Word;
Begin
  If HiRes Then FillRectangleX(X1,Y1,X2 + 1,Y2 + 1,0,Color)
  Else
  Begin
    If X2 < X1 Then SwapInt(X1,X2);
    If Y2 < Y1 Then SwapInt(Y1,Y2);
    Asm
      MOV   AX,WORD PTR Y1
      SUB   BX,BX
      MOV   BH,AL
      SHL   AX,6
      ADD   BX,AX
      MOV   DI,BX
      ADD   DI,WORD PTR X1
      MOV   WORD PTR Addr,DI
    End; { Asm }
    Len  := X2 - X1 + 1;
    For Y := Y1 To Y2 Do
    Begin
      FillChar(Mem[$A000:Addr],Len,Color);
      Inc(Addr,320);
    End; { For Y }
  End;
End; { FBox }

Function Debug(Buf: Pointer; Var PC: Word; Var P,A,X,Y,S: Byte;
               ROMBackup: Pointer; GameRes: TGameRes;
               Var HaltLine: Integer; Var BreakExpColl: PCollection;
               Var Game: TSave{; SN1,SN2,SN3,SN4: Word}): Boolean;

Const
  Timer_And : Array[$0..$1F] Of Byte =
   ($80,$81,$82,$83,$84,$85,$84,$85,$80,$81,$82,$83,$84,$85,$84,$85,
{    $94,$95,$96,$97,$94,$95,$96,$97,$94,$95,$96,$97,$94,$95,$96,$97);}
    $94,$95,$96,$97,$94,$95,$96,$97,$94,$95,$96,$97,$94,$95,$96,$97);

Var
  I,J,K    : Word;
  B        : Byte;
  DataTop  : Word;
  Opcode   : Byte;
  Addr     : Word;
  OTyp     : String[3];
  Operand  : String;
  Color    : Word;
  TopAddr  : Word;
  Ch,Ch1   : Char;
  Access   : Word;
  AccSize  : Word;
  Switch   : Boolean;
  Temp     : Boolean;
  _DLines  : Word;
  St       : String;
  HaltNum  : Integer;
  Code     : Integer;
  HexVal   : LongInt;
  HexAddr  : LongInt;
  OutFile  : File;
  ExpError : Boolean;

  Function TransWordWrite(Addr: Word): String;
  Begin
    If (Addr < $80) Or ((Addr >= $100) And (Addr < $180)) Then Addr := Addr And $3F;
    Case Addr Of
      0..$2C: TransWordWrite := TIA_Name[Addr];
{  $280..$297: TransWordWrite := PIA_Name[Addr];
  $380..$397: TransWordWrite := PIA_Name[Addr - $100];}
    $200..$3FF: TransWordWrite := PIA_Name[$200 Or Timer_And[Addr And $1F]];
    Else TransWordWrite := HexWord(Addr);
    End; { Case }
  End; { TransWordWrite }


  Function TransWordRead(Addr: Word): String;
  Begin
    Case Addr Of
      0..$7F,$100..$17F: TransWordRead := TIA_Read_Name[Addr And $F];
    $200..$3FF: TransWordRead := PIA_Name[$200 Or Timer_And[Addr And $1F]];
{  $280..$297: TransWordRead := PIA_Name[Addr];
  $380..$397: TransWordRead := PIA_Name[Addr - $100];}
     Else TransWordRead := HexWord(Addr);
     End; { Case }
  End; { TransWordRead }


  Function TransByteRead(Addr: Word): String;
  Begin
    Case Addr Of
      0..$7F,$100..$17F: TransByteRead := TIA_Read_Name[Addr And $F];
    $200..$3FF: TransByteRead := PIA_Name[$200 Or Timer_And[Addr And $1F]];
{  $280..$297: TransByteRead := PIA_Name[Addr];
  $380..$397: TransByteRead := PIA_Name[Addr - $100];}
     Else TransByteRead := HexByte(Addr);
     End; { Case }
  End; { TransByteRead }


  Function TransByteWrite(Addr: Word): String;
  Begin
    If (Addr < $80) Or ((Addr >= $100) And (Addr < $180)) Then Addr := Addr And $3F;
    Case Addr Of
      0..$2C: TransByteWrite := TIA_Name[Addr];
    Else TransByteWrite := HexByte(Addr);
    End; { Case }
  End; { TransByteWrite }


  Function TransWord(Addr: Word): String;
  Var Instr: String[3];
  Begin
    Instr := Mnem[Opcode];
    If (Addr < $80) And (Copy(Instr,1,2) = 'RO')
     Then TransWord := TransWordRead(Addr)
     Else
      If (Instr           = 'ADC') Or
         (Instr           = 'DEC') Or
         (Instr           = 'INC') Or
         (Instr           = 'SBC') Or
         (Copy(Instr,1,2) = 'PH')  Or
         (Copy(Instr,1,2) = 'RO')  Or
         (Copy(Instr,1,2) = 'ST')
       Then TransWord := TransWordWrite(Addr)
       Else TransWord := TransWordRead(Addr);
  End; { TransWord }


  Function TransByte(Addr: Word): String;
  Var Instr: String[3];
  Begin
    Instr := Mnem[Opcode];
    If (Addr < $80) And (Copy(Instr,1,2) = 'RO')
     Then TransByte := TransByteRead(Addr)
     Else
      If (Instr           = 'ADC') Or
         (Instr           = 'DEC') Or
         (Instr           = 'INC') Or
         (Instr           = 'SBC') Or
         (Copy(Instr,1,2) = 'PH')  Or
         (Copy(Instr,1,2) = 'RO')  Or
         (Copy(Instr,1,2) = 'ST')
       Then TransByte := TransByteWrite(Addr)
       Else TransByte := TransByteRead(Addr);
  End; { TransByte }


  Procedure SaveGameScreen;
  Var P: BPtr;
  Begin
    GetMem(Win,GameScreenSize);
    P := Win;
    If GameRes >= gr160x200A Then Move(Mem[$A000:0],Win^,GameScreenSize)
    Else
    Begin
      Asm
        PUSH  DS
        LES   DI,DWORD PTR P
        SUB   SI,SI
        MOV   AX,0A000h
        MOV   DS,AX
        CLD
        MOV   DX,200
@L2:
        MOV   CX,160
@L1:
        MOVSB
        INC   SI
        LOOP  @L1
        DEC   DX
        JNZ   @L2
        POP   DS
      End; { Asm }
    End;
  End; { SaveGameScreen }


  Procedure RestoreRow(Row: Word);
  Var
    Addr : Word;
    P    : BPtr;

  Begin
    Addr := Row * 160;
    P    := Win;
    Inc(LongInt(P),Addr);
    If GameRes >= gr160x200A Then Move(P^,Mem[$A000:Addr],160)
    Else
    Begin
      Asm
        PUSH  DS
        MOV   DI,WORD PTR Addr
        ADD   DI,DI
        MOV   AX,0A000h
        MOV   ES,AX
        LDS   SI,DWORD PTR P
        MOV   CX,160
        CLD
@L1:
        LODSB
        MOV   AH,AL
        STOSW
        LOOP  @L1
        POP   DS
      End; { Asm }
    End;
  End; { RestoreRow }


  Procedure RestoreColumn(Col: Word);
  Var P: BPtr;
  Begin
    P := Win;
    If GameRes >= gr160x200A Then
    Begin
      Asm
        PUSH  DS
        MOV   DI,WORD PTR Col
        MOV   AX,0A000h
        MOV   ES,AX
        LDS   SI,DWORD PTR P
        ADD   SI,WORD PTR Col
        MOV   CX,200
        CLD
@L1:
        MOVSB
        ADD   SI,159
        ADD   DI,159
        LOOP  @L1
        POP   DS
      End; { Asm }
    End
    Else
    Begin
      Asm
        PUSH  DS
        MOV   DI,WORD PTR Col
        ADD   DI,DI
        MOV   AX,0A000h
        MOV   ES,AX
        LDS   SI,DWORD PTR P
        ADD   SI,WORD PTR Col
        MOV   CX,200
        CLD
@L1:
        LODSB
        MOV   AH,AL
        STOSW
        ADD   SI,159
        ADD   DI,318
        LOOP  @L1
        POP   DS
      End; { Asm }
    End;
  End; { RestoreColumn }


  Procedure RestoreGameScreen;
  Var I: Integer;
  Begin
    If GameRes >= gr160x200A
     Then Move(Win^,Mem[$A000:0],GameScreenSize)
     Else For I := 0 To 199 Do RestoreRow(I);
    FreeMem(Win,GameScreenSize);
    Win := Nil;
  End; { RestoreGameScreen }


  Procedure FlipWindow;
  Var
    I,J       : Word;
    Pal       : Array[0..767] Of Byte;
    Ch        : Char;
    Buf       : Array[0..319] Of Byte;
    Marker    : Boolean;
    MarkObj   : Boolean;
    Width     : Word;
    Cnt       : Integer;
    Pos       : Integer;

  Begin
    Port[$3C7] := 0;
    For I := 0 To 767 Do Pal[I] := Port[$3C9];
    Temp := HiRes;
    If HiRes Then Set320By200Mode;
    HiRes := False;
    Case GameRes Of
      gr160x200A..gr160x305A:
      Begin
        Go_Mode($D);
        Set160ColsA;
        Port[$3C8] := 0;
        For I := 0 To 767 Do Port[$3C9] := Pal[I];
      End;
      gr160x200B..gr160x305B:
      Begin
        Go_Mode($13);
        Set160ColsB;
        Port[$3C8] := 0;
        For I := 0 To 767 Do Port[$3C9] := Pal[I];
      End;
    End; { Case }
    For I := 0 To 199 Do RestoreRow(I);
    Marker  := False;
    MarkObj := False;
    If GameRes >= gr160x200A Then Width := 160 Else Width := 320;
    Repeat
      Ch := ReadKey;
      If Ch = '=' Then
      Begin
        If (Game.TIA_Scan >= 0) And (Game.TIA_Scan <= 199) Then
        Begin
          Marker := Not Marker;
          Cnt    := Game.TIA_Count;
          If Cnt < 0 Then Cnt := 0;
          If Marker Then
          Begin
            MarkObj := False;
            FillChar(Mem[$A000:Game.TIA_Scan * Width],Width,#15);
            If Width = 160 Then
            Begin
              For I := 0 To 199 Do Mem[$A000:Cnt + I * Width] := 15;
            End
            Else
            Begin
              For I := 0 To 199 Do MemW[$A000:Cnt * 2 + I * Width] := $0F0F;
            End;
          End
          Else
          Begin
            RestoreRow(Game.TIA_Scan);
            RestoreColumn(Cnt);
          End;
        End;
      End;
      If Ch = '-' Then
      Begin
        If (Game.TIA_Scan >= 0) And (Game.TIA_Scan <= 199) Then
        Begin
          MarkObj := Not MarkObj;
          Cnt := Game.TIA_Count;
          If Cnt < 0 Then Cnt := 0;
          If MarkObj Then
          Begin
            Marker := False;

            Pos := Game.ObjectLoc[Index_Player0Set];
            If (Pos >= 0) And (Pos < 160) Then
            Begin
              If Width = 320 Then Pos := Pos * 2;
              Mem[$A000:Game.TIA_Scan * Width + Pos] := 15;
            End;

            Pos := Game.ObjectLoc[Index_Player1Set];
            If (Pos >= 0) And (Pos < 160) Then
            Begin
              If Width = 320 Then Pos := Pos * 2;
              Mem[$A000:Game.TIA_Scan * Width + Pos] := 15;
            End;

            Pos := Game.ObjectLoc[Index_Missile0Set];
            If (Pos >= 0) And (Pos < 160) Then
            Begin
              If Width = 320 Then Pos := Pos * 2;
              Mem[$A000:Game.TIA_Scan * Width + Pos] := 15;
            End;

            Pos := Game.ObjectLoc[Index_Missile1Set];
            If (Pos >= 0) And (Pos < 160) Then
            Begin
              If Width = 320 Then Pos := Pos * 2;
              Mem[$A000:Game.TIA_Scan * Width + Pos] := 15;
            End;

            Pos := Game.ObjectLoc[Index_BallSet];
            If (Pos >= 0) And (Pos < 160) Then
            Begin
              If Width = 320 Then Pos := Pos * 2;
              Mem[$A000:Game.TIA_Scan * Width + Pos] := 15;
            End;
          End
          Else
          Begin
            RestoreRow(Game.TIA_Scan);
            RestoreColumn(Cnt);
          End;
        End;
      End;
    Until Not (Ch In ['-','=']);
    If GameRes >= gr160x200A Then Go_Mode($13);
    HiRes := Temp;
    If HiRes Then Set320By400Mode;
    Port[$3C8] := 0;
    For I := 0 To 767 Do Port[$3C9] := Pal[I];
  End; { FlipWindow }


  Procedure Display;
  Var I,J: Integer;

    Procedure ShowBasicInfo;
    Var I: Integer;
    Begin
      Box(252,0,319,19,LineColor);
      Box(252,21,319,72,LineColor);
      FBox(253,1,318,18,FlagsColor);
      FBox(253,22,318,71,RegsColor);

      WriteOut(254,2,'NV BDIZC' ,NormTextColor + (FlagsColor Shl 8));
      WriteOut(254,23,'PC=    h',NormTextColor + (RegsColor Shl 8));
      WriteOut(254,31,' P=  h  ',NormTextColor + (RegsColor Shl 8));
      WriteOut(254,39,' A=  h  ',NormTextColor + (RegsColor Shl 8));
      WriteOut(254,47,' X=  h  ',NormTextColor + (RegsColor Shl 8));
      WriteOut(254,55,' Y=  h  ',NormTextColor + (RegsColor Shl 8));
      WriteOut(254,63,' S=  h  ',NormTextColor + (RegsColor Shl 8));
      WriteSmOut(254, 76,'Scan=   ',NormTextColor + (ScrDatColor Shl 8));
      WriteSmOut(254, 84,'HPix=   ',NormTextColor + (ScrDatColor Shl 8));
      WriteSmOut(254, 92,'Bank=   ',NormTextColor + (ScrDatColor Shl 8));
      WriteSmOut(254,100,'Addr=   ',NormTextColor + (ScrDatColor Shl 8));
      WriteSmOut(254,108,'GRP0=   ',NormTextColor + (ScrDatColor Shl 8));
      WriteSmOut(254,116,'GRP1=   ',NormTextColor + (ScrDatColor Shl 8));

      { Display flag data }

      For I := 0 To 7 Do
      Begin
        If (P And (1 Shl I)) <> 0
         Then WriteOut(310 - I * 8,10,'1',HiTextColor + (FlagsColor Shl 8))
         Else WriteOut(310 - I * 8,10,'0',HiTextColor + (FlagsColor Shl 8));
      End; { For I }

      { Display reg data }

      WriteOut(278,23,HexWord(PC),HiTextColor + (RegsColor Shl 8));
      WriteOut(278,31,HexByte(P) ,HiTextColor + (RegsColor Shl 8));
      WriteOut(278,39,HexByte(A) ,HiTextColor + (RegsColor Shl 8));
      WriteOut(278,47,HexByte(X) ,HiTextColor + (RegsColor Shl 8));
      WriteOut(278,55,HexByte(Y) ,HiTextColor + (RegsColor Shl 8));
      WriteOut(278,63,HexByte(S) ,HiTextColor + (RegsColor Shl 8));

      { Display screen info data }

      WriteOut(284, 76,IntToStr(Game.TIA_Scan)  ,HiTextColor + (ScrDatColor Shl 8));
      WriteOut(284, 84,IntToStr(Game.TIA_Count) ,HiTextColor + (ScrDatColor Shl 8));
      WriteOut(284, 92,IntToStr(Game.CurrentBank)  ,HiTextColor + (ScrDatColor Shl 8));
      WriteOut(284,100,HexWord(Game.Addr),HiTextColor + (ScrDatColor Shl 8));
      WriteOut(284,108,HexByte(Game.TIA_Regs[GRP0]) + 'h',HiTextColor + (ScrDatColor Shl 8));
      WriteOut(284,116,HexByte(Game.TIA_Regs[GRP1]) + 'h',HiTextColor + (ScrDatColor Shl 8));
    End; { ShowBasicInfo }

  Begin
    If HiRes Then
    Begin
      FBox(0,0,319,399,BackColor);
      Box(0,0,250,259,LineColor);
      Box(0,333,319,399,LineColor);
      Box(252,74,319,125,LineColor);
      Box(0,261,319,287,LineColor);
      Box(0,289,319,299,LineColor);
      Box(0,301,319,311,LineColor);
      FBox(1,1,249,258,DisasmColor);
      FBox(1,334,318,398,DataColor);
      FBox(253,75,318,124,ScrDatColor);
      FBox(1,262,318,286,TIA_Color);
      FBox(1,290,318,298,TIA_Color);
      FBox(1,302,318,310,DataColor + 1);

      ShowBasicInfo;

      WriteOut(254,127,'F1-Help',FlagsColor + (BackColor Shl 8));
{
      WriteOut(254,135,IntToStr(MemAvail),FlagsColor + (BackColor Shl 8));

      WriteOut(254,145,IntToStr(SN1),FlagsColor + (BackColor Shl 8));
      WriteOut(254,155,IntToStr(SN2),FlagsColor + (BackColor Shl 8));
      WriteOut(254,165,IntToStr(SN3),FlagsColor + (BackColor Shl 8));
      WriteOut(254,175,IntToStr(SN4),FlagsColor + (BackColor Shl 8));
}
      { Display data area }

      For I := 0 To DataLines - 1 Do
      Begin
        WriteOut(2,335 + I * 8,HexWord(DataTop + I * $10),NormTextColor + (DataColor Shl 8));
        For J := 0 To $F Do
        Begin
          WriteSmOut(44 + J * 17,335 + I * 8,
           HexByte(Mem[Seg(Buf^):Ofs(Buf^) + DataTop + I * $10 + J]),
           NormTextColor + (DataColor Shl 8));
          If (J And $F) = 7 Then
           DrawLineX(44 + J * 17 + 12,338 + I * 8,44 + J * 17 + 15,338 + I * 8,
            0,NormTextColor + (DataColor Shl 8));
        End; { For J }
      End; { For I }

      { Display TIA registers }

      For I := 0 To $2C Do
      Begin
        If (I And $F) = 0 Then
         WriteOut(2,263 + (I Shr 1),HexWord(I),NormTextColor + (TIA_Color Shl 8));
        WriteSmOut(44 + (I And $F) * 17,263 + ((I Shr 1) And $FFF8),
         HexByte(Game.TIA_Regs[I]),
         NormTextColor + (TIA_Color Shl 8));
        If (I And $F) = 7 Then
         DrawLineX(44 + (I And $F) * 17 + 12,266 + ((I Shr 1) And $FFF8),
                   44 + (I And $F) * 17 + 15,266 + ((I Shr 1) And $FFF8),
          0,NormTextColor + (DataColor Shl 8));
      End; { For I }

      { Display input registers }

      For I := 0 To $F Do
      Begin
        If (I And $F) = 0 Then
         WriteOut(2,291 + (I Shr 1),HexWord(I),NormTextColor + (TIA_Color Shl 8));
        WriteSmOut(44 + (I And $F) * 17,291 + ((I Shr 1) And $FFF8),
         HexByte(Game.Input_Byte[I]),
         NormTextColor + (TIA_Color Shl 8));
        If (I And $F) = 7 Then
         DrawLineX(44 + (I And $F) * 17 + 12,294 + ((I Shr 1) And $FFF8),
                   44 + (I And $F) * 17 + 15,294 + ((I Shr 1) And $FFF8),
          0,NormTextColor + (DataColor Shl 8));
      End; { For I }

      { Display object locations }

      If Mem[Seg(Buf^):Ofs(Buf^) + GRP0] <> 0 Then
      Begin
        WriteOut(2,303,'P0',NormTextColor + (DataColor Shl 8));
        WriteSmOut(20,303,IntToStr(Game.ObjectLoc[Index_Player0Set] And $FFFF),
         ScrDatColor + (DataColor Shl 8));
      End
      Else
      Begin
        WriteOut(2,303,'P0',NormTextColor + (DataColor Shl 8));
        WriteSmOut(20,303,IntToStr(Game.ObjectLoc[Index_Player0Set] And $FFFF),
         NormTextColor + (DataColor Shl 8));
      End;

      If Mem[Seg(Buf^):Ofs(Buf^) + GRP1] <> 0 Then
      Begin
        WriteOut(44,303,'P1',NormTextColor + (DataColor Shl 8));
        WriteSmOut(62,303,IntToStr(Game.ObjectLoc[Index_Player1Set] And $FFFF),
         ScrDatColor + (DataColor Shl 8));
      End
      Else
      Begin
        WriteOut(44,303,'P1',NormTextColor + (DataColor Shl 8));
        WriteSmOut(62,303,IntToStr(Game.ObjectLoc[Index_Player1Set] And $FFFF),
         NormTextColor + (DataColor Shl 8));
      End;

      If (Mem[Seg(Buf^):Ofs(Buf^) + ENAM0] And 2) <> 0 Then
      Begin
        WriteOut(86,303,'M0',NormTextColor + (DataColor Shl 8));
        WriteSmOut(104,303,IntToStr(Game.ObjectLoc[Index_Missile0Set] And $FFFF),
         ScrDatColor + (DataColor Shl 8));
      End
      Else
      Begin
        WriteOut(86,303,'M0',NormTextColor + (DataColor Shl 8));
        WriteSmOut(104,303,IntToStr(Game.ObjectLoc[Index_Missile0Set] And $FFFF),
         NormTextColor + (DataColor Shl 8));
      End;

      If (Mem[Seg(Buf^):Ofs(Buf^) + ENAM1] And 2) <> 0 Then
      Begin
        WriteOut(128,303,'M1',NormTextColor + (DataColor Shl 8));
        WriteSmOut(146,303,IntToStr(Game.ObjectLoc[Index_Missile1Set] And $FFFF),
         ScrDatColor + (DataColor Shl 8));
      End
      Else
      Begin
        WriteOut(128,303,'M1',NormTextColor + (DataColor Shl 8));
        WriteSmOut(146,303,IntToStr(Game.ObjectLoc[Index_Missile1Set] And $FFFF),
         NormTextColor + (DataColor Shl 8));
      End;

      If (Mem[Seg(Buf^):Ofs(Buf^) + ENABL] And 2) <> 0 Then
      Begin
        WriteOut(170,303,'BL',NormTextColor + (DataColor Shl 8));
        WriteSmOut(188,303,IntToStr(Game.ObjectLoc[Index_BallSet] And $FFFF),
         ScrDatColor + (DataColor Shl 8));
      End
      Else
      Begin
        WriteOut(170,303,'BL',NormTextColor + (DataColor Shl 8));
        WriteSmOut(188,303,IntToStr(Game.ObjectLoc[Index_BallSet] And $FFFF),
         NormTextColor + (DataColor Shl 8));
      End;
    End
    Else
    Begin
      FBox(0,0,319,199,BackColor);
      Box(0,0,250,131,LineColor);
      Box(0,133,319,199,LineColor);
      Box(252,74,319,124,LineColor);
      FBox(1,1,249,130,DisasmColor);
      FBox(1,134,318,198,DataColor);
      FBox(253,75,318,123,ScrDatColor);

      ShowBasicInfo;

      WriteOut(254,125,'F1-Help',FlagsColor + (BackColor Shl 8));

      { Display data area }

      For I := 0 To DataLines - 1 Do
      Begin
        WriteOut(2,135 + I * 8,HexWord(DataTop + I * $10),NormTextColor + (DataColor Shl 8));
        For J := 0 To $F Do
        Begin
          WriteSmOut(44 + J * 17,135 + I * 8,
           HexByte(Mem[Seg(Buf^):Ofs(Buf^) + DataTop + I * $10 + J]),
           NormTextColor + (DataColor Shl 8));
          If (J And $F) = 7 Then
           Line(44 + J * 17 + 12,138 + I * 8,44 + J * 17 + 15,138 + I * 8,
            NormTextColor + (DataColor Shl 8));
        End; { For J }
      End; { For I }
    End;
  End; { Display }


  Procedure GetImage(X1,Y1,X2,Y2: Word; Var P);
  Var X,Y,Addr,Dest: LongInt;
  Begin
    If HiRes Then
    Begin
      For Y := Y1 To Y2 Do
      Begin
        Addr := Y * 320 + X1;
        Dest := (Y - Y1) * (X2 - X1 + 1);
        For X := X1 To X2 Do
        Begin
          Asm
            CLI
            MOV   DX,03CEh
            MOV   AL,4
            MOV   AH,BYTE PTR Addr
            ADD   AH,BYTE PTR X
            SUB   AH,BYTE PTR X1
            AND   AH,3
            OUT   DX,AX
            STI
          End; { Asm }
{
          Port[$3CE] := 4;
          Port[$3CF] := (Addr + X) And 3;
}
          Mem[Seg(P):Ofs(P) + Dest + (X - X1)] := Mem[$A000:(Addr + X - X1) Shr 2];
        End; { For X }
      End; { For Y }
{
      Port[$3CE] := 4;
      Port[$3CF] := 0;
}
      Asm
        CLI
        MOV   DX,03CEh
        MOV   AL,4
        MOV   AH,0
        OUT   DX,AX
        STI
      End; { Asm }
    End
    Else
    Begin
      For Y := Y1 To Y2 Do
      Begin
        Addr := Y * 320 + X1;
        Dest := (Y - Y1) * (X2 - X1 + 1);
        Move(Mem[$A000:Addr],Mem[Seg(P):Ofs(P) + Dest],X2 - X1 + 1);
      End; { For Y }
    End;
  End; { GetImage }


  Procedure PutImage(X1,Y1,W,H: Word; Var P);
  Var X,Y,Addr,Source: LongInt;
  Begin
    If HiRes Then CopySystemToScreenX(0,0,W,H,X1,Y1,@P,0,W,320)
    Else
    Begin
      For Y := Y1 To Y1 + H - 1 Do
      Begin
        Addr   := Y * 320 + X1;
        Source := (Y - Y1) * W;
        Move(Mem[Seg(P):Ofs(P) + Source],Mem[$A000:Addr],W);
      End; { For Y }
    End;
  End; { PutImage }


  Function GetText(X1,Y1,X2,Y2: Integer; InitString: String; Fore,Back: Byte; MaxLen,WindowLen: Integer): String;
  { ---------------------------------------------------------------------- }
  { Allows the user to type in a text string in graphics mode              }
  {    X1 ................. Upper left X coord of text input box           }
  {    Y1 ................. Upper left Y coord of text input box           }
  {    X2 ................. Lower right X coord of text input box          }
  {    Y2 ................. Lower right Y coord of text input box          }
  {    InitString ......... Initial text string                            }
  {    Fore ............... Text foreground color                          }
  {    Back ............... Text background color                          }
  {    MaxLen ............. Maximum string length                          }
  {    WindowLen .......... Displayed string length, for scrollable window }
  { ---------------------------------------------------------------------- }
  Const
    TextWidth  = 8;
    TextHeight = 8;

  Var
    Work  : String;
    Ch    : Char;
    Ch1   : Char;
    Top   : Integer;
    X     : Integer;
    Ins   : Boolean;
    TPtr  : Pointer;
    On    : Boolean;
    Pen   : Word;
    Brush : Word;

    Function ImageSize(X1,Y1,X2,Y2: Word): Word;
    Begin
      ImageSize := (X2 - X1 + 1) * (Y2 - Y1 + 1);
    End; { ImageSize }


    Function Max(A,B: Integer): Integer;
    Begin
      If A >= B Then Max := A Else Max := B;
    End; { Max }


    Function Min(A,B: Integer): Integer;
    Begin
      If A <= B Then Min := A Else Min := B;
    End; { Min }


    Procedure Cursor;
    { --------------------------------- }
    { Toggle to display/hide the cursor }
    { --------------------------------- }
    Begin
      If On Then
      Begin
        Pen   := Back;
        Brush := Back;
      End
      Else
      Begin
        Pen   := Fore;
        Brush := Fore;
      End;
      If Ins
       Then FBox(X1 + (X - Top)     * TextWidth + 1,Y1 + 4,
                 X1 + (X - Top + 1) * TextWidth,Y1 + TextHeight,Brush)
       Else FBox(X1 + (X - Top)     * TextWidth + 1,Y1 + TextHeight,
                 X1 + (X - Top + 1) * TextWidth,Y1 + TextHeight,Pen);
      On := Not On;
      If Not On Then
      Begin
        Pen   := Fore;
        Brush := Back;
        WriteOut(X1 + (X - Top) * TextWidth + 1,Y1 + 1,
         Copy(Work,X,1),Pen + (Brush Shl 8));
      End;
      Pen   := Fore;
      Brush := Fore;
    End; { Cursor }


    Procedure ScrollLeft;
    { --------------------------- }
    { Scroll the text window left }
    { --------------------------- }
    Var W,H,S: Word;
    Begin
      Inc(Top);
      S := ImageSize(X1 + TextWidth + 1,Y1,X2,Y2);
      GetMem(TPtr,S);
      GetImage(X1 + TextWidth + 1,Y1,X2,Y2,TPtr^);
      W     := X2 - (X1 + TextWidth + 1) + 1;
      H     := Y2 - Y1 + 1;
      Pen   := Back;
      Brush := Back;
      FBox(X1 + (WindowLen - 1) * TextWidth + 1,Y1,X2,Y2,Brush);
      Pen   := Fore;
      PutImage(X1 + 1,Y1,W,H,TPtr^);
      WriteOut(X1 + (WindowLen) * TextWidth + 1,Y1 + 1,
       Copy(Work,Top + WindowLen,1),Pen + (Brush Shl 8));
      FreeMem(TPtr,S);
    End; { ScrollLeft }


    Procedure ScrollRight;
    { ---------------------------- }
    { Scroll the text window right }
    { ---------------------------- }
    Var W,H,S: Word;
    Begin
      Dec(Top);
      S := ImageSize(X1 + TextWidth + 1,Y1,X2 + (WindowLen - 1) * TextWidth,Y2);
      GetMem(TPtr,S);
      GetImage(X1 + 1,Y1,X2 - TextWidth,Y2,TPtr^);
      W     := (X2 - TextWidth) - (X1 + 1) + 1;
      H     := Y2 - Y1 + 1;
      Pen   := Back;
      Brush := Back;
      FBox(X1,Y1,X1 + TextWidth,Y2,Brush);
      Pen   := Fore;
      PutImage(X1 + TextWidth + 1,Y1,W,H,TPtr^);
      WriteOut(X1 + 1,Y1 + 1,Copy(Work,Top,1),Pen + (Brush Shl 8));
      FreeMem(TPtr,S);
    End; { ScrollRight }

  Begin
    Work := InitString;{'';}
    Top  := 1;
    X    := 1;
    Ins  := False;
    On   := False;

    { Blank the window }

    Pen   := Back;
    Brush := Back;
    FBox(X1,Y1,X2,Y2,Brush);
    Pen   := Fore;

    WriteOut(X1 + 1,Y1 + 1,Copy(Work,1,WindowLen + 1),Pen + (Brush Shl 8));

    Cursor;
    Ch := ' ';
    While Not (Ch In [#13,#27]) Do
    Begin
      If KeyPressed Then
      Begin
        Ch := ReadKey;
        Case Ch Of
     #13,#27: Begin
              End;
          #8: Begin                                   { Backspace }
                If X > 1 Then
                Begin
                  Cursor;
                  Delete(Work,X - 1,1);
                  If X > Top Then
                  Begin
                    Pen   := Back;
                    Brush := Back;
                    FBox(X1 + (X - Top - 1) * TextWidth + 1,Y1 + 1,X2 - 1,Y2 - 1,Brush);
                    Pen   := Fore;
                    WriteOut(X1 + (X - Top - 1) * TextWidth + 1,Y1 + 1,
                             Copy(Work,X - 1,WindowLen - (X - Top) + 1),Pen + (Brush Shl 8));
                  End;
                  Dec(X);
                  If X < Top Then ScrollRight;
                  Cursor;
                End;
              End;
          #0: Begin
                While Not KeyPressed Do Begin End;
                Ch1 := ReadKey;
                Case Ch1 Of
                  #71: If X > 1 Then                  { Home }
                       Begin
                         Cursor;
                         If Top <> 1 Then
                         Begin
                           Pen   := Back;
                           Brush := Back;
                           FBox(X1,Y1,X2,Y2,Brush);
                           Pen := Fore;
                           Top := 1;
                           WriteOut(X1 + 1,Y1 + 1,Copy(Work,1,WindowLen + 1),Pen + (Brush Shl 8));
                         End;
                         X := 1;
                         Cursor;
                       End;
                  #75: If X > 1 Then                  { Cursor Left }
                       Begin
                         Cursor;
                         Dec(X);
                         If X < Top Then ScrollRight;
                         Cursor;
                       End;
                  #77: If X <= Length(Work) Then      { Cursor Right }
                       Begin
                         Cursor;
                         Inc(X);
                         If X - Top = WindowLen Then ScrollLeft;
                         Cursor;
                       End;
                  #79: If X <= Length(Work) Then      { End }
                       Begin
                         Cursor;
                         If Top < Length(Work) - WindowLen + 2 Then
                         Begin
                           Pen   := Back;
                           Brush := Back;
                           FBox(X1,Y1,X2,Y2,Brush);
                           Pen   := Fore;
                           Top   := Length(Work) - WindowLen + 2;
                           WriteOut(X1 + 1,Y1 + 1,Copy(Work,Top,WindowLen),Pen + (Brush Shl 8));
                         End;
                         X := Length(Work) + 1;
                         Cursor;
                       End;
                  #82: Begin                          { Insert }
                         Cursor;
                         Ins := Not Ins;
                         Cursor;
                       End;
                  #83: Begin                          { Delete }
                         If ((Work <> '') And (X <= Length(Work))) Then
                         Begin
                           Cursor;
                           Delete(Work,X,1);
                           Pen   := Back;
                           Brush := Back;
                           FBox(X1 + (X - Top) * TextWidth + 1,Y1 + 1,X2 - 1,Y2 - 1,Brush);
                           Pen   := Fore;
                           WriteOut(X1 + (X - Top) * TextWidth + 1,Y1 + 1,
                            Copy(Work,X,WindowLen - (X - Top) + 1),Pen + (Brush Shl 8));
                           Cursor;
                         End;
                       End;
                End; { Case }
              End;
        Else
          Cursor;
          If (X > Length(Work)) Or Ins Then
          Begin
            If (Length(Work) < MaxLen) Then
            Begin
              Insert(Ch,Work,X);
              Pen   := Back;
              Brush := Back;
              FBox(X1 + (X - Top) * TextWidth + 1,Y1 + 1,X2 - 1,Y2 - 1,Brush);
              Pen   := Fore;
              WriteOut(X1 + (X - Top) * TextWidth + 1,Y1 + 1,
               Copy(Work,X,WindowLen - (X - Top) + 1),Pen + (Brush Shl 8));
            End;
          End
          Else
          Begin
            Work[X] := Ch;
            Pen   := Back;
            Brush := Back;
            FBox(X1 + (X - Top)     * TextWidth + 1,Y1 + 1,
                 X1 + (X - Top + 1) * TextWidth    ,Y2 - 1,Brush);
            Pen   := Fore;
            WriteOut(X1 + (X - Top) * TextWidth + 1,Y1 + 1,Copy(Work,X,1),Pen + (Brush Shl 8));
          End;
          If Not ((X > Length(Work)) And (Length(Work) = MaxLen)) Then
          Begin
            Inc(X);
             { Check to see if I must scroll the text left }
             If X - Top = WindowLen Then ScrollLeft;
          End;
          Cursor;
        End; { Case }
      End;
    End; { While }
    If Ch = #27 Then Work := InitString;
    Pen   := Back;
    Brush := Back;
    FBox(X1,Y1,X2,Y2,Brush);
    Pen   := Fore;
    WriteOut(X1 + 1,Y1 + 1,Copy(Work,1,WindowLen),Pen + (Brush Shl 8));
    GetText := Work;
  End; { GetText }

  Procedure DisplayHelp;
  Var
    I  : Integer;
    St : String;

  Begin
    Temp := HiRes;
    If HiRes Then Set320By200Mode;
    HiRes := False;
    FBox(0,0,319,199,HelpColor);

    Color := HelpHiColor + (HelpColor Shl 8);
    WriteOut(0,0,  'F1',Color);
    WriteOut(0,8,  'D',Color);
    WriteOut(0,16, 'E',Color);
    WriteOut(0,24, 'G',Color);
    WriteOut(0,32, 'H',Color);
    WriteOut(0,40, 'L',Color);
    WriteOut(0,48, 'P',Color);
    WriteOut(0,56, 'R',Color);
    WriteOut(0,64, 'S',Color);
    WriteOut(0,72, 'T',Color);
    WriteOut(0,80, 'X',Color);
    WriteOut(0,88, 'Z',Color);
    WriteOut(0,96, '<Space>',Color);
    WriteOut(0,104,'-',Color);
    WriteOut(0,112,'=',Color);

    WriteOut(0,120,'<Up>',Color);
    WriteOut(0,128,'<Down>',Color);
    WriteOut(0,136,'<PgUp>',Color);
    WriteOut(0,144,'<PgDn>',Color);
    WriteOut(0,152,'<Home>',Color);
    WriteOut(0,160,'<End>',Color);
    WriteOut(0,168,'<Ins>',Color);

    Color := HelpTextColor + (HelpColor Shl 8);
    WriteOut(56,0,  ' - Help',Color);
    WriteOut(56,8,  ' - Toggle 320x400 mode',Color);
    WriteOut(56,16, ' - Enter data at addr. (not TIA)',Color);
    WriteOut(56,24, ' - Begin execution of code',Color);
    WriteOut(56,32, ' - Execute to hilighted position',Color);
    WriteOut(56,40, ' - Execute until scan line',Color);
    WriteOut(56,48, ' - Move to specified address',Color);
    WriteOut(56,56, ' - Change 6507 register',Color);
    WriteOut(56,64, ' - Execute over next instruction',Color);
    WriteOut(56,72, ' - Execute next instruction',Color);
    WriteOut(56,80, ' - Enter break expression',Color);
    WriteOut(56,88, ' - Save 4k ROM to disk',Color);
    WriteOut(56,96, ' - Toggle game screen display',Color);
    WriteOut(56,104,' - (game screen) show object pos.',Color);
    WriteOut(56,112,' - (game screen) show CRT pos.',Color);

    WriteOut(56,120,' - Move up one byte',Color);
    WriteOut(56,128,' - Move down one instruction',Color);
    WriteOut(56,136,' - Move up one screen',Color);
    WriteOut(56,144,' - Move down one screen',Color);
    WriteOut(56,152,' - Move to 1000h',Color);
    WriteOut(56,160,' - Move to 1FFFh',Color);
    WriteOut(56,168,' - Move to current instruction',Color);

    Color := ScrDatColor + (HelpColor Shl 8);
    WriteOut(0,184,'Hit <Space> for more, or',Color);
    WriteOut(0,192,'any other key to return',Color);

    Ch1 := ReadKey;
    If Ch1 = #32 Then
    Begin
      FBox(0,0,319,199,HelpColor);
      Color := HelpHiColor + (HelpColor Shl 8);
      For I := 0 To $2C Do
      Begin
        St := HexByte(I);
        While Length(St) < 2 Do St := '0' + St;
        If I < $17
         Then WriteOut(8,I * 8,St,Color)
         Else WriteOut(160,(I - $17) * 8,St,Color);
      End;
      Color := HelpTextColor + (HelpColor Shl 8);
      For I := 0 To $2C Do
      Begin
        If I < $17
         Then WriteOut(32,I * 8,'- ' + TIA_Name[I],Color)
         Else WriteOut(184,(I - $17) * 8,'- ' + TIA_Name[I],Color);
      End;
      Color := ScrDatColor + (HelpColor Shl 8);
      WriteOut(0,184,'Hit <Space> for more, or',Color);
      WriteOut(0,192,'any other key to return',Color);
      Ch1 := ReadKey;
      If Ch1 = #32 Then
      Begin
        FBox(0,0,319,199,HelpColor);
        Color := HelpHiColor + (HelpColor Shl 8);
        WriteOut(0,0,  ' "E" command syntax:',Color);
        WriteOut(0,32, ' "R" command syntax:',Color);
        WriteOut(0,72, ' Break expression arguments:',Color);
        Color := HelpTextColor + (HelpColor Shl 8);
        WriteOut(0,8,  '  <address>=<value>',Color);
        WriteOut(0,16, '  e.g. 125F=28 places 28h into [125Fh]',Color);

        WriteOut(0,40, '  <register>=<value>',Color);
        WriteOut(0,48, '  e.g. A=28 places 28h into reg. A',Color);
        WriteOut(0,56, '  Available registers: PC P A X Y S',Color);

        WriteOut(0,80, '  CX .......... CRT beam X position',Color);
        WriteOut(0,88, '  CY .......... CRT beam Y position',Color);
        WriteOut(0,96, '  P0 .......... Player 0 position',Color);
        WriteOut(0,104,'  P1 .......... Player 1 position',Color);
        WriteOut(0,112,'  M0 .......... Missile 0 position',Color);
        WriteOut(0,120,'  M1 .......... Missile 1 position',Color);
        WriteOut(0,128,'  BL .......... Ball position',Color);
        WriteOut(0,136,'  A ........... Register A contents',Color);
        WriteOut(0,144,'  X ........... Register X contents',Color);
        WriteOut(0,152,'  Y ........... Register Y contents',Color);
        WriteOut(0,160,'  P ........... Register P contents',Color);
        WriteOut(0,168,'  S ........... Register S contents',Color);
        WriteOut(0,176,'  PC .......... Register PC contents',Color);
        WriteOut(0,184,'  [address] ... Memory contents',Color);
        Color := ScrDatColor + (HelpColor Shl 8);


        WriteOut(0,192,'<Space> for more, any other key to exit',Color);
{        WriteOut(0,184,'Hit <Space> for more, or',Color);
        WriteOut(0,192,'any other key to return',Color);}
        Ch1 := ReadKey;
        If Ch1 = #32 Then
        Begin
          FBox(0,0,319,199,HelpColor);
          Color := HelpHiColor + (HelpColor Shl 8);
          WriteOut(0,0,  ' Break expression operators:',Color);
          Color := HelpTextColor + (HelpColor Shl 8);
          WriteOut(0,8,  '  + ......... Addition',Color);
          WriteOut(0,16, '  - ......... Subtraction',Color);
          WriteOut(0,24, '  * ......... Multiplication',Color);
          WriteOut(0,32, '  / ......... Integer Division',Color);
          WriteOut(0,40, '  % ......... Modulo',Color);

          WriteOut(0,56, '  && ........ Boolean and',Color);
          WriteOut(0,64, '  || ........ Boolean or',Color);
          WriteOut(0,72, '  ^^ ........ Boolean xor',Color);
          WriteOut(0,80, '  ! or ~ .... Boolean not',Color);

          WriteOut(0,96, '  & ......... Bitwise and',Color);
          WriteOut(0,104,'  | ......... Bitwise or',Color);
          WriteOut(0,112,'  ^ ......... Bitwise xor',Color);

          WriteOut(0,128,'  = or == ... Bool/num equality',Color);
          WriteOut(0,136,'  <> or != .. Bool/num inequality',Color);
          WriteOut(0,144,'  < ......... Less than',Color);
          WriteOut(0,152,'  > ......... Greater than',Color);
          WriteOut(0,160,'  <= ........ Less than or equal',Color);
          WriteOut(0,168,'  >= ........ Greater than or equal',Color);

          WriteOut(0,184,'  ( or ) .... Parentheses',Color);
          ReadKey;
        End;
      End;
    End;
    HiRes := Temp;
    If HiRes Then Set320By400Mode;
  End; { DisplayHelp }

  Function InputBox(Const Prompt,OldString: String): String;
  Var
    LineWinData : Pointer;
    W,H,X1,Y1,X2,Y2,I : Integer;

  Begin
    W := 241;
    H := 41;
    X1 := (320 - (W - 1)) Div 2;
    Y1 := (200 - (H - 1)) Div 2;
    X2 := X1 + W - 1;
    Y2 := Y1 + H - 1;
    I  := (W - Length(Prompt) * 8) Div 2;
    GetMem(LineWinData,W * H);
    GetImage(X1,Y1,X2,Y2,LineWinData^);
    FBox(X1,Y1,X2,Y2,PopupColor);
    Box(X1,Y1,X2,Y2,ScrDatColor);
    WriteOut(X1 + I,Y1 + 2,Prompt,NormTextColor + (PopupColor Shl 8));
    InputBox := GetText(X1 + 2,Y1 + 16,X2 - 2,Y1 + 25,OldString,HiTextColor,TextBGColor,128,29);
    PutImage(X1,Y1,W,H,LineWinData^);
    FreeMem(LineWinData,W * H);
  End; { InputBox }

  Procedure MessageBox(Const Message: String);
  Var
    LineWinData       : Pointer;
    W,H,X1,Y1,X2,Y2,I : Integer;

  Begin
    W  := (Length(Message) + 1) * 8 + 1;
    H  := 41;
    If W < 80 Then W := 80;
    X1 := (320 - (W - 1)) Div 2;
    Y1 := (200 - (H - 1)) Div 2;
    X2 := X1 + W - 1;
    Y2 := Y1 + H - 1;
    I  := (W - 72) Div 2;
    GetMem(LineWinData,W * H);
    GetImage(X1,Y1,X2,Y2,LineWinData^);
    FBox(X1,Y1,X2,Y2,PopupColor);
    Box(X1,Y1,X2,Y2,ScrDatColor);
    WriteOut(X1 + 4    ,Y1 + 8 ,Message,NormTextColor + (PopupColor Shl 8));
    WriteOut(X1 + 4 + I,Y1 + 24,'Hit a key',NormTextColor + (PopupColor Shl 8));
    ReadKey;
    PutImage(X1,Y1,W,H,LineWinData^);
    FreeMem(LineWinData,W * H);
  End; { MessageBox }

Begin
{  If MouseVisible Then ToggleMouseVisibility;}
  TopAddr := PC;
  DataTop := $80;
  SaveGameScreen;


{  __DispWin(Win);}
  If HiRes Then Set320By400Mode;
  Display;
  Repeat

    { Display instructions }

{    If MouseVisible Then ToggleMouseVisibility;}
    Addr := TopAddr And $1FFF;
    If HiRes
     Then _DLines := HRDisasmLines
     Else _DLines := DisasmLines;
    For I := 0 To _DLines - 1 Do
    Begin
      If Addr = (PC And $1FFF) Then
      Begin
        Color := PCTextColor + (HiTextColor   Shl 8);
        FBox(2,2 + I * 8,248,9 + I * 8,HiTextColor);
      End
      Else
      Begin
        Color := NormTextColor + (DisasmColor Shl 8);
        FBox(2,2 + I * 8,248,9 + I * 8,DisasmColor);
      End;
      Opcode := Mem[Seg(Buf^):Ofs(Buf^) + Addr];

      If HiRes
       Then WriteSmOut(2,2 + I * 8,HexWord(Addr),Color)
       Else WriteOut(2,2 + I * 8,HexWord(Addr),Color);

      For J := 0 To Bytes[Opcode] - 1 Do
      Begin
        WriteSmOut(44 + J * 12,2 + I * 8,
         HexByte(Mem[Seg(Buf^):Ofs(Buf^) + Addr + J]),Color);
      End; { For J }

      { Write cycles }
{
      If HiRes Then
       WriteSmOut(30,2 + I * 8,IntToStr(Cycles[Opcode]),Color);
}
      If HiRes
       Then WriteSmOut(88,2 + I * 8,Mnem[Opcode],Color)
       Else WriteOut(88,2 + I * 8,Mnem[Opcode],Color);

      OTyp    := ATyp[Opcode];
      Operand := '';
      If OTyp = 'ABS' Then Operand := TransWord(MemW[Seg(Buf^):Ofs(Buf^) + Addr + 1] And $1FFF);
      If OTyp = 'A.X' Then Operand := TransWord(MemW[Seg(Buf^):Ofs(Buf^) + Addr + 1] And $1FFF) + ',X';
      If OTyp = 'A.Y' Then Operand := TransWord(MemW[Seg(Buf^):Ofs(Buf^) + Addr + 1] And $1FFF) + ',Y';
      If OTyp = 'ASY' Then Operand := '(' + TransWord(MemW[Seg(Buf^):Ofs(Buf^) + Addr + 1] And $1FFF) + ',Y) & S';
      If OTyp = 'IND' Then Operand := '(' + HexWord(MemW[Seg(Buf^):Ofs(Buf^) + Addr + 1] And $1FFF) + ')';
      If OTyp = 'I.X' Then Operand := '(' + HexByte(Mem[Seg(Buf^):Ofs(Buf^) + Addr + 1]) + ',X)';
      If OTyp = 'I.Y' Then Operand := '(' + HexByte(Mem[Seg(Buf^):Ofs(Buf^) + Addr + 1]) + '),Y';
      If OTyp = 'ACC' Then Operand := 'A';
      If OTyp = 'IMM' Then Operand := '#' + HexByte(Mem[Seg(Buf^):Ofs(Buf^) + Addr + 1]);
      If OTyp = 'Z.P' Then Operand := TransByte(Mem[Seg(Buf^):Ofs(Buf^) + Addr + 1]);
      If OTyp = 'Z.X' Then Operand := TransByte(Mem[Seg(Buf^):Ofs(Buf^) + Addr + 1]) + ',X';
      If OTyp = 'Z.Y' Then Operand := TransByte(Mem[Seg(Buf^):Ofs(Buf^) + Addr + 1]) + ',Y';
      If OTyp = 'I+A' Then Operand := '#' + HexByte(Mem[Seg(Buf^):Ofs(Buf^) + Addr + 1]) + ' + A';
      If OTyp = 'REL' Then
      Begin
        B := Mem[Seg(Buf^):Ofs(Buf^) + Addr + 1];
        Asm
          MOV   BX,WORD PTR Addr
          ADD   BX,2
          MOV   AL,BYTE PTR B
          CBW
          ADD   BX,AX
          MOV   WORD PTR J,BX
        End; { Asm }
        Operand := HexWord(J);
      End;

      If HiRes
       Then WriteSmOut(136,2 + I * 8,Operand,Color)
       Else WriteOut(136,2 + I * 8,Operand,Color);

      Inc(Addr,Bytes[Opcode]);
    End; { For I }
    Ch := UpCase(ReadKey);
    If Ch = 'D' Then
    Begin
      HiRes := Not HiRes;
      If HiRes Then Set320By400Mode Else Set320By200Mode;
      Display;
    End;
    If Ch = 'S' Then
    Begin
      Opcode := Mem[Seg(Buf^):Ofs(Buf^) + PC];
      Game.OldStart := PC + Bytes[Opcode];
    End;
    If Ch = 'H' Then
    Begin
      Opcode := Mem[Seg(Buf^):Ofs(Buf^) + TopAddr];
      Game.OldStart := TopAddr;
    End;
    If Ch = 'G' Then Game.OldStart := 0;
    If Ch = 'L' Then
    Begin
      St := UpperCase(Trim(InputBox('Scan line','')));
      If St <> '' Then
      Begin
        Val(St,HaltNum,Code);
        If Code = 0 Then
        Begin
          HaltLine := HaltNum;
          Game.OldStart := 0;
        End
        Else Ch := 'l';
      End
      Else Ch := 'l';  { Don't let it exit }
    End;
    If Ch = 'Z' Then
    Begin
      St := UpperCase(Trim(InputBox('Save to disk','')));
      If St <> '' Then
      Begin
      {$I-}
        Assign(OutFile,St);
        ReWrite(OutFile,1);
      {$I+}
        If IOResult = 0 Then
        Begin
          BlockWrite(OutFile,Mem[Seg(Buf^):Ofs(Buf^) + $1000],$1000);
          Close(OutFile);
        End;
      End;
    End;
    If Ch = 'X' Then
    Begin
      St := UpperCase(Trim(InputBox('Enter expression',BreakExp)));

      { Get rid of the last break expression collection, if any }

      If BreakExpColl <> Nil Then
      Begin
        Dispose(BreakExpColl,Done);
        BreakExpColl := Nil;
      End;
      ExpError := False;
      If St <> '' Then
      Begin
        BreakExpColl := PostFix(St);
        If BreakExpColl <> Nil Then
        Begin

          { Try to evaluate it to make sure it's ok (ignore the result) }

          Evaluate(BreakExpColl,Buf,0,0,0,0,0,0,0,0,0,0,0,0,0,ExpError);
          If ExpError Then
          Begin
            Dispose(BreakExpColl,Done);
            BreakExpColl := Nil;
            St := '';
          End;
        End
        Else
        Begin
          St       := '';
          ExpError := True;
        End;
      End;
      BreakExp := St;  { Remember the last one }
      If ExpError Then MessageBox('Error in expression');
    End;
    If Ch = 'E' Then
    Begin
      St := UpperCase(Trim(InputBox('Enter data','')));
      If St <> '' Then
      Begin
        Code := Pos('=',St);
        If Code <> 0 Then
        Begin
          HexAddr := ValHex(Trim(Copy(St,1,Code - 1)));
          If (HexAddr >= 0) And ((HexAddr And $1FFF) >= $80) Then
          Begin
            HexAddr := HexAddr And $1FFF;
            St   := Trim(Copy(St,Code + 1,Length(St) - Code));
            Code := Pos(' ',St);
            If (Code = 0) And (St <> '') Then Code := Length(St) + 1;
            While Code <> 0 Do
            Begin
              HexVal := ValHex(Trim(Copy(St,1,Code - 1)));
              If HexVal >= 0 Then Mem[Seg(Buf^):Ofs(Buf^) + HexAddr] := HexVal And $FF;
              Inc(HexAddr);
              St   := Trim(Copy(St,Code + 1,Length(St) - Code));
              Code := Pos(' ',St);
              If (Code = 0) And (St <> '') Then Code := Length(St) + 1;
            End; { While }
            Display;
          End;
        End;
      End;
    End;
    If Ch = 'P' Then
    Begin
      St := Trim(InputBox('Enter address in hex',''));
      If St <> '' Then
      Begin
        HexAddr := ValHex(St);
        If (HexAddr >= 0) And (HexAddr <= $1FFF) Then TopAddr := HexAddr;
      End;
    End;
    If Ch = 'R' Then
    Begin
      St := UpperCase(Trim(InputBox('Enter reg=value (hex)','')));
      Code := Pos(' ',St);
      While Code <> 0 Do
      Begin
        Delete(St,Code,1);
        Code := Pos(' ',St);
      End; { While }
      If St <> '' Then
      Begin
        If Copy(St,1,3) = 'PC=' Then
        Begin
          HexVal := ValHex(Copy(St,4,Length(St) - 3));
          If HexVal >= 0 Then
          Begin
            PC := HexVal;{ And $1FFF;}
            Display;
          End;
        End;
        If Copy(St,1,2) = 'P=' Then
        Begin
          HexVal := ValHex(Copy(St,3,Length(St) - 2));
          If HexVal >= 0 Then
          Begin
            P := HexVal And $FF;
            Display;
          End;
        End;
        If Copy(St,1,2) = 'A=' Then
        Begin
          HexVal := ValHex(Copy(St,3,Length(St) - 2));
          If HexVal >= 0 Then
          Begin
            A := HexVal And $FF;
            Display;
          End;
        End;
        If Copy(St,1,2) = 'X=' Then
        Begin
          HexVal := ValHex(Copy(St,3,Length(St) - 2));
          If HexVal >= 0 Then
          Begin
            X := HexVal And $FF;
            Display;
          End;
        End;
        If Copy(St,1,2) = 'Y=' Then
        Begin
          HexVal := ValHex(Copy(St,3,Length(St) - 2));
          If HexVal >= 0 Then
          Begin
            Y := HexVal And $FF;
            Display;
          End;
        End;
        If Copy(St,1,2) = 'S=' Then
        Begin
          HexVal := ValHex(Copy(St,3,Length(St) - 2));
          If HexVal >= 0 Then
          Begin
            S := HexVal And $FF;
            Display;
          End;
        End;
      End;
    End;
    If Ch = 'T' Then
    Begin
      Opcode := Mem[Seg(Buf^):Ofs(Buf^) + PC];
      OTyp    := ATyp[Opcode];
      If Mnem[Opcode] = 'JSR' Then
      Begin
        Game.OldStart := MemW[Seg(Buf^):Ofs(Buf^) + PC + 1] And $1FFF;
      End
      Else
       If Mnem[Opcode] = 'JMP' Then
       Begin
         If OTyp = 'ABS'
          Then Game.OldStart := MemW[Seg(Buf^):Ofs(Buf^) + PC + 1] And $1FFF
          Else Game.OldStart := MemW[Seg(Buf^):Ofs(Buf^) + MemW[Seg(Buf^):Ofs(Buf^) + PC + 1] And $1FFF] And $1FFF;
       End
       Else
        If Mnem[Opcode] = 'BPL' Then
        Begin
          If (P And $80) = 0
           Then Game.OldStart := PC + ShortInt(Mem[Seg(Buf^):Ofs(Buf^) + PC + 1] + 2)
           Else Game.OldStart := PC + Bytes[Opcode];
        End
        Else
         If Mnem[Opcode] = 'BMI' Then
         Begin
           If (P And $80) <> 0
            Then Game.OldStart := PC + ShortInt(Mem[Seg(Buf^):Ofs(Buf^) + PC + 1] + 2)
            Else Game.OldStart := PC + Bytes[Opcode];
         End
         Else
          If Mnem[Opcode] = 'BVC' Then
          Begin
            If (P And $40) = 0
             Then Game.OldStart := PC + ShortInt(Mem[Seg(Buf^):Ofs(Buf^) + PC + 1] + 2)
             Else Game.OldStart := PC + Bytes[Opcode];
          End
          Else
           If Mnem[Opcode] = 'BVS' Then
           Begin
             If (P And $40) <> 0
              Then Game.OldStart := PC + ShortInt(Mem[Seg(Buf^):Ofs(Buf^) + PC + 1] + 2)
              Else Game.OldStart := PC + Bytes[Opcode];
           End
           Else
            If Mnem[Opcode] = 'BCC' Then
            Begin
              If (P And 1) = 0
               Then Game.OldStart := PC + ShortInt(Mem[Seg(Buf^):Ofs(Buf^) + PC + 1] + 2)
               Else Game.OldStart := PC + Bytes[Opcode];
            End
            Else
             If Mnem[Opcode] = 'BCS' Then
             Begin
               If (P And 1) <> 0
                Then Game.OldStart := PC + ShortInt(Mem[Seg(Buf^):Ofs(Buf^) + PC + 1] + 2)
                Else Game.OldStart := PC + Bytes[Opcode];
             End
             Else
              If Mnem[Opcode] = 'BNE' Then
              Begin
                If (P And 2) = 0
                 Then Game.OldStart := PC + ShortInt(Mem[Seg(Buf^):Ofs(Buf^) + PC + 1] + 2)
                 Else Game.OldStart := PC + Bytes[Opcode];
              End
              Else
               If Mnem[Opcode] = 'BEQ' Then
               Begin
                 If (P And 2) <> 0
                  Then Game.OldStart := PC + ShortInt(Mem[Seg(Buf^):Ofs(Buf^) + PC + 1] + 2)
                  Else Game.OldStart := PC + Bytes[Opcode];
               End
               Else
                If Mnem[Opcode] = 'RTS' Then Game.OldStart := (MemW[Seg(Buf^):Ofs(Buf^) + S + 1] + 1) And $1FFF
                Else
                 If Mnem[Opcode] = 'BRK' Then Game.OldStart := MemW[Seg(Buf^):Ofs(Buf^) + $1FFE] And $1FFF
                 Else
                  If Mnem[Opcode] = 'RTI' Then Game.OldStart := MemW[Seg(Buf^):Ofs(Buf^) + S + 2] And $1FFF
                  Else Game.OldStart := PC + Bytes[Opcode];
(*
      { Check to see if the intervening instruction does any bank switching }

      AccSize := 1;
      Access  := 0;
      If OTyp = 'ABS' Then
      Begin
        If Mnem[Opcode] <> 'JSR'
         Then Access  := MemW[Seg(Buf^):Ofs(Buf^) + PC + 1]
         Else
         Begin
           Access  := S + $100 - 1;
           AccSize := 2;
         End;
      End
      Else
       If OTyp = 'A.X' Then Access  := MemW[Seg(Buf^):Ofs(Buf^) + PC + 1] + X
       Else
        If OTyp = 'A.Y' Then Access  := MemW[Seg(Buf^):Ofs(Buf^) + PC + 1] + Y
        Else
         If OTyp = 'Z.P' Then Access := Mem[Seg(Buf^):Ofs(Buf^) + PC + 1]
         Else
          If OTyp = 'Z.X' Then Access := Mem[Seg(Buf^):Ofs(Buf^) + PC + 1] + X
          Else
           If OTyp = 'IND' Then Access := MemW[Seg(Buf^):Ofs(Buf^) + MemW[Seg(Buf^):Ofs(Buf^) + PC + 1]]
           Else
            If OTyp = 'I.X' Then Access := MemW[Seg(Buf^):Ofs(Buf^) + MemW[Seg(Buf^):Ofs(Buf^) + PC + 1 + X]]
            Else
             If OTyp = 'I.Y' Then Access := MemW[Seg(Buf^):Ofs(Buf^) + MemW[Seg(Buf^):Ofs(Buf^) + PC + 1]] + Y
             Else
             Begin
               If Mnem[Opcode] = 'RTS' Then
               Begin
                 Access  := S + $101;
                 AccSize := 2;
               End
               Else
                If Copy(Mnem[Opcode],1,2) = 'PH' Then Access := S + $100
                Else
                 If Copy(Mnem[Opcode],1,2) = 'PL' Then Access := S + $101
                 Else
                  If Mnem[Opcode] = 'BRK' Then
                  Begin
                    Access  := S + $100 - 2;
                    AccSize := 3;
                  End
                  Else
                   If Mnem[Opcode] = 'RTI' Then
                   Begin
                     Access  := S + $100;
                     AccSize := 3;
                   End
                   Else
                   Begin
                     Access  := 0;
                     AccSize := 0;
                   End;
             End;
      Access := Access And $1FFF;
      Switch := False;
      While (AccSize > 0) And Not Switch Do
      Begin
        If Not (BS^[Access + AccSize - 1] In [0,$30])
         Then Switch := True
         Else Dec(AccSize);
      End; { While }
      If Switch Then
      Begin
        I := BS^[Access + AccSize - 1];
        Case I Of
   1..16: Begin

            WriteSmOut(0,0,'NewStart=' + HexWord(NewStart) + 'h',NormTextColor + (ScrDatColor Shl 8));
            WriteSmOut(0,8,'Dest=' + HexWord((I - 1) * 1024 + Game.OldStart - $1000),NormTextColor + (ScrDatColor Shl 8));
            ReadKey;

            OldByte := Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + (I - 1) * 1024 + Game.OldStart - $1000];
            Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + (I - 1) * 1024 + Game.OldStart - $1000] := BreakInstruction;
          End;
   17,21: Begin
            OldByte := Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + ((I Xor 4) - 17) * 1024 + Game.OldStart - $1000];
            Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + ((I Xor 4) - 17) * 1024 + Game.OldStart - $1000] := BreakInstruction;
          End;
  33..41: Begin
            OldByte := Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + (I - 33) * 1024 + Game.OldStart - $1000];
            Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + (I - 33) * 1024 + Game.OldStart - $1000] := BreakInstruction;
          End;
$D0..$D7: Begin
            If Game.OldStart < $1800 Then
            Begin
              I := I And 7;
              If I = 7 Then Inc(I);
              OldByte := Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + I * 2048 + Game.OldStart - $1000];
              Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + I * 2048 + Game.OldStart - $1000] := BreakInstruction;
            End;
          End;
$E0..$F7: Begin
            If (((I And $18) Shl 15) + $1000) = (NewStart And $1C00) Then
            Begin
              OldByte := Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + (I And 7) * 1024 + Game.OldStart - $1000];
              Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + (I And 7) * 1024 + Game.OldStart - $1000] := BreakInstruction;
            End;
          End;
        End; { Case }
      End
      Else
      Begin
        OldByte  := Mem[Seg(Buf^):Ofs(Buf^) + NewStart];
        Mem[Seg(Buf^):Ofs(Buf^) + NewStart] := BreakInstruction;
      End;
*)
    End;
    If Ch = ' ' Then
    Begin
      FlipWindow;
      Display;
    End;
    If Ch = #0 Then
    Begin
      Ch := ReadKey;
      Case Ch Of
        #59: Begin                         { F1 }
               DisplayHelp;
               Display;
             End;
        #71: TopAddr := $1000;             { Home }
        #72: Begin                         { Up }
               If TopAddr > 0 Then Dec(TopAddr);
             End;
        #73: Begin                         { PgUp }
               I := TopAddr;
               Repeat
                 J := 0;
                 K := I;
                 While K < TopAddr Do
                 Begin
                   Inc(J);
                   Opcode := Mem[Seg(Buf^):Ofs(Buf^) + K];
                   Inc(K,Bytes[Opcode]);
                 End; { While }
                 If J < _DLines - 1 Then Dec(I);
               Until J >= _Dlines - 1;
               TopAddr := I;
             End;
        #79: TopAddr := $1FFF;             { End }
        #80: Begin                         { Down }
               Opcode := Mem[Seg(Buf^):Ofs(Buf^) + TopAddr];
               Inc(TopAddr,Bytes[Opcode]);
             End;
        #81: TopAddr := Addr;              { PgDn }
        #82: TopAddr := PC;                { Insert }
      End; { Case }
      Ch := #0;
    End;
  Until Ch In [#27,'S','T','H','G','L'];

{  For I := 0 To 127 Do Line(I,198,I,199,I * 2);}
  While Keypressed Do ReadKey;
  If HiRes Then Set320By200Mode;
{  __RemWin;}
  RestoreGameScreen;
  Debug := (Ch In ['S','T','H','G','L']);
End; { Debug }

Begin
  GetModeDValues;
  BreakExp := '';
  If LoadSmallFont Then
  Begin
    Win         := Nil;
    _WindowList := Nil;
    _ListWork   := Nil;
    OldExitProc := ExitProc;
    ExitProc    := @NewExitProc;
{    __MakeWin(Win,0,0,319,199,BackColor);}
{    __MakeWin(HelpWin,0,0,319,199,DataColor);}
  End
  Else ErrorLoadingSmallFont;
End.