Unit SPUnit;
{ DEFINE LOG}
{ DEFINE P2LOG}
Interface

Type
  PASeg = ^TASeg;
  TASeg = Array[0..8191] Of Byte;

Const
  _32BIT_OPERAND = $66;
  _32BIT_ADDRESS = $67;
  playback_freq : Word = 31400;
  Cycles : Array[0..255] Of Byte =
   (7,6,0,8,3,3,5,5, 3,2,2,2,4,4,6,6,  { 00-0F }
    2,5,0,8,4,4,6,6, 2,4,2,7,4,4,7,7,  { 10-1F }
    6,6,0,8,3,3,5,5, 4,2,2,2,4,4,6,6,  { 20-2F }
    2,5,0,8,4,4,6,6, 2,4,2,7,4,4,7,7,  { 30-3F }
    6,6,0,8,3,3,5,5, 3,2,2,2,3,4,6,6,  { 40-4F }
    2,5,0,8,4,4,6,6, 2,4,2,7,4,4,7,7,  { 50-5F }
    6,6,0,8,3,3,5,5, 4,2,2,2,5,4,6,6,  { 60-6F }
    2,5,0,8,4,4,6,6, 2,4,2,7,4,4,7,7,  { 70-7F }
    2,6,2,6,3,3,3,3, 2,2,2,2,4,4,4,4,  { 80-8F }
    2,6,0,6,4,4,4,4, 2,5,2,5,5,5,5,5,  { 90-9F }
    2,6,2,6,3,3,3,3, 2,2,2,2,4,4,4,4,  { A0-AF }
    2,5,0,5,4,4,4,4, 2,4,2,4,4,4,4,4,  { B0-BF }
    2,6,2,8,3,3,5,5, 2,2,2,2,4,4,6,6,  { C0-CF }
    2,5,0,8,4,4,6,6, 2,4,2,7,4,4,7,7,  { D0-DF }
    2,6,2,8,3,3,5,5, 2,2,2,2,4,4,6,6,  { E0-EF }
    2,5,0,8,4,4,6,6, 2,4,2,7,0,4,7,7); { F0-FF }

Var
  SPBank   : Byte;
  SPSearch : Word;
  SPBoot   : Boolean;

  WaveLen : Array[1..4] Of Byte; { The fourth byte is unused in these arrays }
  Pulse   : Array[1..4] Of Byte;
  Phase   : Array[1..4] Of Byte;
  Signal  : Array[1..4] Of Byte;
  Wave    : Array[1..4] Of Byte;
(*
  Old_WaveLen : Array[1..4] Of Byte; { The fourth byte is unused in these arrays }
  Old_Pulse   : Array[1..4] Of Byte;
  Old_Phase   : Array[1..4] Of Byte;
  Old_Signal  : Array[1..4] Of Byte;
  Old_Wave    : Array[1..4] Of Byte;
*)
{
  _Wave    : Array[1..3] Of Integer;
  _WaveLen : Array[1..3] Of Integer;
  _Pulse   : Array[1..3] Of Integer;
}

  { Total values }

  _Wave    : Array[1..3] Of Single;
  _WaveLen : Array[1..3] Of Single;
  _Pulse   : Array[1..3] Of Single;

  { Remainders }

  Rem_Wave    : Array[1..3] Of Single;

{
  SoundQueue                     : Array[0..1025] Of Byte;
  SoundQueue_In                  : Word;
  SoundQueue_Out                 : Word;
  SoundQueue_Num                 : Word;
}
Function HandleStarpath(AtariSeg: PASeg; ROMBackup: Pointer; PC,LastAddr,SPBankNum: Word;
                        TIA_Count,TIA_Scan: Integer; ROMSize: Word): Boolean;
Procedure HandlePitfall2(AtariSeg: PASeg; BSValue,Addr,XY,Acc,PC: Word);
Procedure FillDump(Const P: Pointer);
Procedure LoadStarpath(Var F: File; P: Pointer; Size: Word);
Procedure SaveSPP2Status(Var F: File);
Procedure RestoreSPP2Status(Var F: File);

Implementation

Uses HexWrite,Crt,Keyboard,AtariDbg,AtariDis,TIASound;

Const
  SP1 : Array[0..7] Of Word = ($1000,$0000,$1000,$0000,$1000,$0800,$1000,$0800);
  SP2 : Array[0..7] Of Word = ($1800,$1800,$0000,$1000,$1800,$1800,$0800,$1000);

Type
  PPF2Dump = ^TPF2Dump;
  TPF2Dump = Array[0..2048 + 255 - 1] Of Byte;

Var
  SPWrite     : Boolean;
  SPWriteVal  : Byte;
  Listing     : Text;
  OldExitProc : Pointer;
  C0,S0       : Integer;
  C1,S1       : Integer;
  PF2Dump     : PPF2Dump;
  PF2Read     : Array[0..23] Of Integer;
  PF2ReadB    : Array[0..7] Of Boolean;
  Rand        : Array[0..3] Of Byte;
  SPOfs       : Word;

Procedure SaveSPP2Status(Var F: File);
Begin
  BlockWrite(F,SPWrite,SizeOf(SPWrite));
  BlockWrite(F,SPWriteVal,SizeOf(SPWriteVal));
  BlockWrite(F,C0,SizeOf(C0));
  BlockWrite(F,S0,SizeOf(S0));
  BlockWrite(F,C1,SizeOf(C1));
  BlockWrite(F,S1,SizeOf(S1));
  BlockWrite(F,PF2Dump^,SizeOf(PF2Dump^));
  BlockWrite(F,PF2Read,SizeOf(PF2Read));
  BlockWrite(F,PF2ReadB,SizeOf(PF2ReadB));
  BlockWrite(F,Rand,SizeOf(Rand));
  BlockWrite(F,SPOfs,SizeOf(SPOfs));
End; { SaveSPP2Status }


Procedure RestoreSPP2Status(Var F: File);
Begin
  BlockRead(F,SPWrite,SizeOf(SPWrite));
  BlockRead(F,SPWriteVal,SizeOf(SPWriteVal));
  BlockRead(F,C0,SizeOf(C0));
  BlockRead(F,S0,SizeOf(S0));
  BlockRead(F,C1,SizeOf(C1));
  BlockRead(F,S1,SizeOf(S1));
  BlockRead(F,PF2Dump^,SizeOf(PF2Dump^));
  BlockRead(F,PF2Read,SizeOf(PF2Read));
  BlockRead(F,PF2ReadB,SizeOf(PF2ReadB));
  BlockRead(F,Rand,SizeOf(Rand));
  BlockRead(F,SPOfs,SizeOf(SPOfs));
End; { RestoreSPP2Status }


Procedure LoadStarpath(Var F: File; P: Pointer; Size: Word);
Var
  I,J    : Word;
  Loads  : Word;
  Blocks : Word;
  Dest   : Word;
  Header : Array[0..$57] Of Byte;
  P1     : Pointer;

Begin
  Loads := Size Div 8448;
  Seek(F,0);
  BlockRead(F,P^,Size);
  For I := 0 To Loads - 1 Do
  Begin
    If I > 0 Then
     Move(Mem[Seg(P^):Ofs(P^) + (I - 1) * 8448],
          Mem[Seg(P^):Ofs(P^) + I       * 8448],8192);
    Seek(F,I * 8448 + $2000);
    BlockRead(F,Header,SizeOf(Header));
    Blocks := Header[3];
    For J := 0 To Blocks - 1 Do
    Begin
      Seek(F,I * 8448 + J * 256);
      Dest := Header[J + $10];
      Dest := ((Dest And $1C) Shl 6) + ((Dest And 3) Shl 11) + I * 8448;
      P1   := Ptr(Seg(P^),Ofs(P^) + Dest);
      BlockRead(F,P1^,256);
    End; { For J }
  End; { For I }
End; { LoadStarpath }


Function HandleStarpath(AtariSeg: PASeg; ROMBackup: Pointer; PC,LastAddr,SPBankNum: Word;
                        TIA_Count,TIA_Scan: Integer; ROMSize: Word): Boolean;
Const
  Boot: Array[0..$B] Of Byte =
   ($AD,$00,$0E,$A2,$FF,$A0,$00,$A9,$00,$4C,$F7,$00);

Var
  Opcode : Byte;
  Addr1  : Word;
  Addr2  : Word;
  Addr3  : Word;

  CInc1  : Integer;
  CInc2  : Integer;
  CInc3  : Integer;
  CInc4  : Integer;

  OTyp   : String[3];
  J      : Word;
  B      : Byte;

  Buf    : Pointer;
  Found  : Boolean;
  Index  : Byte;
  Start  : Word;

  Function TransWordWrite(Addr: Word): String;
  Begin
    If Addr < $80 Then Addr := Addr And $3F;
    Case Addr Of
      0..$2C: TransWordWrite := TIA_Name[Addr];
  $280..$297: TransWordWrite := PIA_Name[Addr];
  $380..$397: TransWordWrite := PIA_Name[Addr - $100];
    Else TransWordWrite := HexWord(Addr);
    End; { Case }
  End; { TransWordWrite }


  Function TransWordRead(Addr: Word): String;
  Begin
    Case Addr Of
      0..$7F: TransWordRead := TIA_Read_Name[Addr And $F];
  $280..$297: TransWordRead := PIA_Name[Addr];
  $380..$397: TransWordRead := PIA_Name[Addr - $100];
    Else TransWordRead := HexWord(Addr);
    End; { Case }
  End; { TransWordRead }


  Function TransByteRead(Addr: Word): String;
  Begin
    Case Addr Of
      0..$7F: TransByteRead := TIA_Read_Name[Addr And $F];
  $280..$297: TransByteRead := PIA_Name[Addr];
  $380..$397: TransByteRead := PIA_Name[Addr - $100];
     Else TransByteRead := HexByte(Addr);
     End; { Case }
  End; { TransByteRead }


  Function TransByteWrite(Addr: Word): String;
  Begin
    If Addr < $80 Then Addr := Addr And $3F;
    Case Addr Of
      0..$2C: TransByteWrite := TIA_Name[Addr];
    Else TransByteWrite := HexByte(Addr);
    End; { Case }
  End; { TransByteWrite }


  Function TransWord(Addr: Word): String;
  Var Instr: String[3];
  Begin
    Instr := Mnem[Opcode];
    If (Addr < $80) And (Copy(Instr,1,2) = 'RO')
     Then TransWord := TransWordRead(Addr)
     Else
      If (Instr           = 'ADC') Or
         (Instr           = 'DEC') Or
         (Instr           = 'INC') Or
         (Instr           = 'SBC') Or
         (Copy(Instr,1,2) = 'PH')  Or
         (Copy(Instr,1,2) = 'RO')  Or
         (Copy(Instr,1,2) = 'ST')
       Then TransWord := TransWordWrite(Addr)
       Else TransWord := TransWordRead(Addr);
  End; { TransWord }


  Function TransByte(Addr: Word): String;
  Var Instr: String[3];
  Begin
    Instr := Mnem[Opcode];
    If (Addr < $80) And (Copy(Instr,1,2) = 'RO')
     Then TransByte := TransByteRead(Addr)
     Else
      If (Instr           = 'ADC') Or
         (Instr           = 'DEC') Or
         (Instr           = 'INC') Or
         (Instr           = 'SBC') Or
         (Copy(Instr,1,2) = 'PH')  Or
         (Copy(Instr,1,2) = 'RO')  Or
         (Copy(Instr,1,2) = 'ST')
       Then TransByte := TransByteWrite(Addr)
       Else TransByte := TransByteRead(Addr);
  End; { TransByte }


  Procedure GetWrite;
  Begin
    If Addr3 > $10FF Then
    Begin
      Addr3 := LastAddr;
      CInc3 := CInc4;
    End;
    If Addr2 > $10FF Then
    Begin
      Addr2 := Addr3;
      CInc2 := CInc3;
    End;
    If Addr1 > $10FF Then
    Begin
      Addr1 := Addr2;
      CInc1 := CInc2;
    End;
    If (Addr1 >= $1000) And (Addr1 <= $10FF) Then
    Begin
      SPWrite    := True;
      SPWriteVal := Addr1{LastAddr} And $FF;
      C0         := TIA_Count;
      S0         := TIA_Scan;
      If S0 > 250 Then S0 := 250;
    End;
  End; { GetWrite }

Begin
  If Not SPBoot Then Move(Boot,AtariSeg^[$0E00],SizeOf(Boot));
(*
  Begin
    AtariSeg^[$0E00] := $AD;   { LDA 0E00 }
    MemW[Seg(AtariSeg^):Ofs(AtariSeg^) + $0E01] := $0E00;
    MemW[Seg(AtariSeg^):Ofs(AtariSeg^) + $0E03] := $FFA2; { LDX #FF  }
    MemW[Seg(AtariSeg^):Ofs(AtariSeg^) + $0E05] := $00A0; { LDY #00  }
    MemW[Seg(AtariSeg^):Ofs(AtariSeg^) + $0E07] := $00A9; { LDA #00  }
    Mem[Seg(AtariSeg^):Ofs(AtariSeg^)  + $0E09] := $4C;   { JMP 00F7 }
    MemW[Seg(AtariSeg^):Ofs(AtariSeg^) + $0E0A] := $00F7;
    SPBoot := True;
  End;
*)
  SPBank         := SPBankNum;
  HandleStarpath := False;
  Opcode         := AtariSeg^[PC];

  If (LastAddr = $0E00) And (PC = $0E00) Then
  Begin
    B        := AtariSeg^[$FA];
    Found    := False;
    SPSearch := 0;
    While (SPSearch < ROMSize) And (SPSearch < 4 * 8448) And Not Found Do
    Begin
      Index := Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + SPSearch + $2005];
      If Index = B Then Found := True Else Inc(SPSearch,8448);
    End; { While }
    If Found Then
    Begin

      FillChar(AtariSeg^[$81],$1D,#0);
      B := Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + SPSearch + $2002];
      AtariSeg^[$80] := B;
      AtariSeg^[$F7] := $CD;   { CMP 1000 }
      AtariSeg^[$F8] := $00;
      AtariSeg^[$F9] := $10;
      AtariSeg^[$FA] := $AD;   { LDA 1FF8 }
      AtariSeg^[$FB] := $F8;
      AtariSeg^[$FC] := $1F;
      Start := MemW[Seg(ROMBackup^):Ofs(ROMBackup^) + SPSearch + $2000];
      AtariSeg^[$FD] := $4C;   { JMP Start }
      MemW[Seg(AtariSeg^):Ofs(AtariSeg^) + $FE] := Start;
      AtariSeg^[$F8]  := B;

      SPBankNum := B;
      Move(Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + SP1[(SPBankNum Shr 2) And 7] + SPSearch],
           AtariSeg^[$1000],$800);
      Move(Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + SP2[(SPBankNum Shr 2) And 7] + SPSearch],
           AtariSeg^[$1800],$800);

{      AtariSeg^[$1FF8] := B;}

      SPWrite        := False;
      SPBank         := SPBankNum;
      HandleStarpath := True;
    End;
    Exit;
  End;


{
  Inc(TIA_Count,3 * Cycles[Opcode]);
  If TIA_Count >= 160 Then
  Begin
    Dec(TIA_Count,228);
    If TIA_Scan < 250 Then Inc(TIA_Scan);
  End;
}

  { Log the instruction }
{$IFDEF LOG}
  Write(Listing,HexWord(PC),'    ',Mnem[Opcode],'   ');
  OTyp := ATyp[Opcode];
  If OTyp = 'ABS' Then Write(Listing,'   ',TransWord(MemW[Seg(AtariSeg^):Ofs(AtariSeg^) + PC + 1] And $1FFF));
  If OTyp = 'A.X' Then Write(Listing,'   ',TransWord(MemW[Seg(AtariSeg^):Ofs(AtariSeg^) + PC + 1] And $1FFF),',X');
  If OTyp = 'A.Y' Then Write(Listing,'   ',TransWord(MemW[Seg(AtariSeg^):Ofs(AtariSeg^) + PC + 1] And $1FFF),',Y');
  If OTyp = 'ASY' Then Write(Listing,'   (',TransWord(MemW[Seg(AtariSeg^):Ofs(AtariSeg^) + PC + 1] And $1FFF),',Y) & S');
  If OTyp = 'IND' Then Write(Listing,'   (',HexWord(MemW[Seg(AtariSeg^):Ofs(AtariSeg^) + PC + 1] And $1FFF),')');
  If OTyp = 'I.X' Then Write(Listing,'   (',HexByte(AtariSeg^[PC + 1]),',X)');
  If OTyp = 'I.Y' Then Write(Listing,'   (',HexByte(AtariSeg^[PC + 1]),'),Y');
  If OTyp = 'ACC' Then Write(Listing,'   A');
  If OTyp = 'IMM' Then Write(Listing,'   #',HexByte(AtariSeg^[PC + 1]));
  If OTyp = 'Z.P' Then Write(Listing,'   ',TransByte(AtariSeg^[PC + 1]));
  If OTyp = 'Z.X' Then Write(Listing,'   ',TransByte(AtariSeg^[PC + 1]),',X');
  If OTyp = 'Z.Y' Then Write(Listing,'   ',TransByte(AtariSeg^[PC + 1]),',Y');
  If OTyp = 'I+A' Then Write(Listing,'   #',HexByte(AtariSeg^[PC + 1]),' + A');
  If OTyp = 'REL' Then
  Begin
    B := AtariSeg^[PC + 1];
    Asm
      MOV   BX,WORD PTR PC
      ADD   BX,2
      MOV   AL,BYTE PTR B
      CBW
      ADD   BX,AX
      MOV   WORD PTR J,BX
    End; { Asm }
    Write(Listing,'   ',HexWord(J));
  End;
  If SPWrite Then Write(Listing,'    ',SPWrite,'  (',HexByte(SPWriteVal),')');
{  WriteLn(Listing);}
{$ENDIF}

  { Get all the addresses that can be accessed }

  If (ATyp[Opcode] = 'A.X') Or           { Absolute X }
     (ATyp[Opcode] = 'A.Y') Or           { Absolute Y }
     (ATyp[Opcode] = 'I.Y') Then         { Indirect Y }
  Begin
    SPOfs := (LastAddr - (MemW[Seg(AtariSeg^):Ofs(AtariSeg^) + PC + 1] And $1FFF)) And $FF;

    If Copy(ATyp[Opcode],1,1) = 'A' Then
    Begin
      Addr1 := MemW[Seg(AtariSeg^):Ofs(AtariSeg^) + PC + 1] And $1FFF;
      Addr3 := (Addr1 And $FF00) + (LastAddr And $FF);
      Addr2 := Addr3;
      Addr1 := Addr3;

      If Opcode In [$19,$1D,$39,$3D,$59,$5D,$79,$7D,$B9,$BB,$BC,$BD,$BE,$BF,$D9,$DD,$F9,$FD] Then
      Begin
        CInc1 := 4;                      { Read }
        CInc2 := 4;
        CInc3 := 4;
        CInc4 := 4;
        If (Addr3 And $FF00) <> (LastAddr And $FF00) Then
        Begin
          Inc(CInc1);
          Inc(CInc2);
          Inc(CInc3);
          Inc(CInc4);
        End;
      End
      Else
       If Opcode In [$99,$9C,$9D,$9E,$9F] Then
       Begin
         CInc1 := 4;                     { Write }
         CInc2 := 4;
         CInc3 := 4;
         CInc4 := 5;
       End
       Else
       Begin
         CInc1 := 4;                     { Read/Modify/Write }
         CInc2 := 5;
         CInc3 := 6;
         CInc4 := 7;
         Addr2 := LastAddr;
         Addr3 := LastAddr;
       End;
    End
    Else
    Begin
{
      Addr1 := MemW[Seg(AtariSeg^):Ofs(AtariSeg^) + PC + 1] And $1FFF;
      Addr2 := MemW[Seg(AtariSeg^):Ofs(AtariSeg^) + Addr1] And $1FFF;
      Addr3 := (Addr2 And $FF00) + (LastAddr And $FF);
      Addr2 := Addr3;
}
      Addr1 := MemW[Seg(AtariSeg^):Ofs(AtariSeg^) + PC + 1] And $FF;
      Addr2 := MemW[Seg(AtariSeg^):Ofs(AtariSeg^) + Addr1] And $1FFF;
      Addr3 := (Addr2 And $FF00) + (LastAddr And $FF);
      Addr1 := Addr3;
      Addr2 := Addr3;

      If Opcode In [$11,$31,$51,$71,$B1,$D1,$F1] Then  
      Begin
        CInc1 := 5;                      { Read }
        CInc2 := 5;
        CInc3 := 5;
        CInc4 := 5;
        If (Addr3 And $FF00) <> (LastAddr And $FF00) Then
        Begin
          Inc(CInc1);
          Inc(CInc2);
          Inc(CInc3);
          Inc(CInc4);
        End;
      End
      Else
       If Opcode In [$91,$93] Then                     
       Begin
         CInc1 := 5;                     { Write }
         CInc2 := 5;
         CInc3 := 5;
         CInc4 := 6;
       End
       Else
       Begin                                           
         CInc1 := 5;                     { Read/Modify/Write }
         CInc2 := 6;
         CInc3 := 7;
         CInc4 := 8;
         Addr2 := LastAddr;
         Addr3 := LastAddr;
       End;
    End;
  End
  Else
  Begin
    CInc4 := Cycles[Opcode];
    CInc1 := CInc4;
    CInc2 := CInc4;
    CInc3 := CInc4;
    Addr1 := LastAddr;                   { Absolute/Indirect X }
    Addr2 := LastAddr;
    Addr3 := LastAddr;
  End;

  CInc1 := CInc1 * 3;
  CInc2 := CInc2 * 3;
  CInc3 := CInc3 * 3;
  CInc4 := CInc4 * 3;

  { Get rid of any addresses that are below the RAM range }

  If Addr3 < $1000 Then
  Begin
    Addr3 := LastAddr;
    CInc3 := CInc4;
  End;
  If Addr2 < $1000 Then
  Begin
    Addr2 := Addr3;
    CInc2 := CInc3;
  End;
  If Addr1 < $1000 Then
  Begin
    Addr1 := Addr2;
    CInc1 := CInc2;
  End;

  Inc(TIA_Count,CInc1);
  If TIA_Count >= 160 Then
  Begin
    Dec(TIA_Count,228);
{    If TIA_Scan < 250 Then} Inc(TIA_Scan);
  End;

  { Check to see if we already have the value to write }
(*
  TextMode(C80);
  WriteLn('SPWrite=',SPWrite);
  WriteLn('Addr1=',HexWord(Addr1));
  WriteLn;
  WriteLn('DSeg=',HexWord(DSeg));
  WriteLn('@SPWrite=',HexWord(Seg(SPWrite)),':',HexWord(Ofs(SPWrite)));
  Key[kSPACE] := 0;
  Repeat Until Key[kSPACE] <> 0;
  Asm
    MOV   AX,13h
    INT   10h
  End; { Asm }
*)



  If SPWrite Then
  Begin
    SPWrite := False;

    { If writing isn't enabled and it's not a bank switch, save this as a }
    { new write value intead if possible                                  }


    C1 := TIA_Count;
    S1 := TIA_Scan;
    If TIA_Scan > S0 Then Inc(C1,228{160} * (TIA_Scan - S0));


    If  (TIA_Scan < S0) Or
        ((TIA_Scan = S0) And (C1 < C0 + 12)) Or
        (C1 > C0 + 18) Or
{       (Addr1 < $1100) Or}

    (   (Addr1 <> $1FF8) And

       (((SPBankNum And 2) = 0) Or
        ((Addr1 >= $1800) And ((SPBankNum And 8) = 0))) )  Then
    Begin

      { Find the first address that accesses 1000-10FF }

      GetWrite;
{$IFDEF LOG}
      WriteLn(Listing);
{$ENDIF}
    End
    Else
    Begin
{
      If TIA_Scan = S0 + 1 Then Inc(TIA_Count,160);
      If TIA_Count <= C0 + 3 * 6 Then Addr1 := LastAddr;
}
{
      If ((Addr1 And $FF) = (LastAddr And $FF)) And
         ((Addr1 And $FF00) = (LastAddr And $FF00) - $100) Then Inc(Addr1,$100);
}


      Addr1 := LastAddr;



      { Write to the location }
{$IFDEF LOG}
      WriteLn(Listing,'   * --> ',HexWord(Addr1) + ' Last= ' + HexWord(LastAddr));
{$ENDIF}
      If Addr1 <> $1FF8 Then AtariSeg^[Addr1] := SPWriteVal;
      If Addr1 = $1FF8 Then
      Begin
        Move(AtariSeg^[$1000],
             Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + SP1[(SPBankNum Shr 2) And 7] + SPSearch],$800);
        Move(AtariSeg^[$1800],
             Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + SP2[(SPBankNum Shr 2) And 7] + SPSearch],$800);

        SPBankNum := SPWriteVal;
        Move(Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + SP1[(SPBankNum Shr 2) And 7] + SPSearch],
             AtariSeg^[$1000],$800);
        Move(Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + SP2[(SPBankNum Shr 2) And 7] + SPSearch],
             AtariSeg^[$1800],$800);

        { If the ROM bank was loaded, fill it in with my routine }

        If SP2[(SPBankNum Shr 2) And 7] = $1800 Then
        Begin
          AtariSeg^[$1800] := $4C;   { JMP 0E00 }
          AtariSeg^[$1801] := $00;
          AtariSeg^[$1802] := $0E;
        End;

        HandleStarpath := True;
        SPBank         := SPBankNum;

        If Addr1 <> $1FF8 Then AtariSeg^[Addr1] := SPWriteVal;


{$IFDEF LOG}
        WriteLn(Listing);
{$ENDIF}

      End;
    End;
  End
  Else
  Begin
{$IFDEF LOG}
    WriteLn(Listing);
{$ENDIF}
    { Find the first address that accesses 1000-10FF }

    GetWrite;
  End;

{  Move(SPWrite,Mem[Seg(AtariSeg^):16384 + 256 + Ofs(SPWrite)],Ofs(S1) - Ofs(SPWrite) + SizeOf(S1) - 1);}


End; { HandleStarpath }

{$F+}
Procedure NewExitProc;
Begin
  ExitProc := OldExitProc;
  Flush(Listing);
  Close(Listing);
  FreeMem(PF2Dump,2048 + 255);
End; { NewExitProc }
{$F-}
(*
Function GetPF2Volume(Incr: Word): Byte;
Const
  Smooth = 10;
  Fudge  = 1.0;

Var
  P        : Pointer;
  I        : LongInt;
  Amp      : Byte;
  LenRatio : Single;
  Changed  : Boolean;

  Mult : Array[1..3] Of Single;

Begin
  Changed := False;
  Asm
    DB    _32BIT_OPERAND
    MOV   AX,WORD PTR Old_WaveLen
    DB    _32BIT_OPERAND
    CMP   AX,WORD PTR WaveLen
    JNE   @L1

    DB    _32BIT_OPERAND
    MOV   AX,WORD PTR Old_Pulse
    DB    _32BIT_OPERAND
    CMP   AX,WORD PTR Pulse
    JNE   @L1

    DB    _32BIT_OPERAND
    MOV   AX,WORD PTR Old_Phase
    DB    _32BIT_OPERAND
    CMP   AX,WORD PTR Phase
    JNE   @L1

    DB    _32BIT_OPERAND
    MOV   AX,WORD PTR Old_Signal
    DB    _32BIT_OPERAND
    CMP   AX,WORD PTR Signal
    JNE   @L1
    JMP   @L2
@L1:
    MOV   BYTE PTR Changed,1
@L2:
  End; { Asm }

  If Changed Then
  Begin

    Mult[1] := 1.75;
    Mult[2] := 1.75;
    Mult[3] := 1.75;

    LenRatio := Playback_Freq / 31400;

    _WaveLen[1] := Round(WaveLen[1] * Mult[1] * LenRatio);
    _WaveLen[2] := Round(WaveLen[2] * Mult[2] * LenRatio);
    _WaveLen[3] := Round(WaveLen[3] * Mult[3] * LenRatio);

    _Pulse[1] := Round(Pulse[1] * Mult[1] * LenRatio);
    _Pulse[2] := Round(Pulse[2] * Mult[2] * LenRatio);
    _Pulse[3] := Round(Pulse[3] * Mult[3] * LenRatio);

    If _WaveLen[1] > 0 Then _Pulse[1] := _Pulse[1] Mod _WaveLen[1];
    If _WaveLen[2] > 0 Then _Pulse[2] := _Pulse[2] Mod _WaveLen[2];
    If _WaveLen[3] > 0 Then _Pulse[3] := _Pulse[3] Mod _WaveLen[3];

    If WaveLen[1] > 0 Then _Wave[1] := _Wave[1] Mod WaveLen[1] Else _Wave[1] := 0;
    If WaveLen[2] > 0 Then _Wave[2] := _Wave[2] Mod WaveLen[2] Else _Wave[2] := 0;
    If WaveLen[3] > 0 Then _Wave[3] := _Wave[3] Mod WaveLen[3] Else _Wave[3] := 0;

    Dec(_Wave[1]);
    Dec(_Wave[2]);
    Dec(_Wave[3]);

    Asm
      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR WaveLen
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_WaveLen,AX

      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR Pulse
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_Pulse,AX

      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR Phase
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_Phase,AX

      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR Signal
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_Signal,AX

      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR Wave
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_Wave,AX
    End; { Asm }
  End;

  { Get the volume }

  Amp := 0;
  For I := 1 To 3 Do
   If _WaveLen[I] > 0
    Then _Wave[I] := (_Wave[I] + Incr) Mod _WaveLen[I]
    Else _Wave[I] := 0;

  Case Signal[1] Of
    1: Amp := $20;
    3: If _Wave[1] <= _Pulse[1] Then Amp := $20;
  End; { Case }

  Case Signal[2] Of
    1: Inc(Amp,$28);
    3: If _Wave[2] <= _Pulse[2] Then Inc(Amp,$28);
  End; { Case }

  Case Signal[3] Of
    1: Inc(Amp,$30);
    3: If _Wave[3] <= _Pulse[3] Then Inc(Amp,$30);
  End; { Case }
{
  Mem[$A000:(PF2Inc Mod 320) + ((Amp Shr 3) * 320)] := 15;
  WriteOut(0,176,IntToStr(Wavelen[1]) + ' ' + IntToStr(Pulse[1]) + ' ' + IntToStr(Phase[1]) + ' ' + IntToStr(Signal[1]),15);
  WriteOut(0,184,IntToStr(Wavelen[2]) + ' ' + IntToStr(Pulse[2]) + ' ' + IntToStr(Phase[2]) + ' ' + IntToStr(Signal[2]),15);
  WriteOut(0,192,IntToStr(Wavelen[3]) + ' ' + IntToStr(Pulse[3]) + ' ' + IntToStr(Phase[3]) + ' ' + IntToStr(Signal[3]),15);
  WriteOut(160,192,IntToStr(Amp),15);
}
  GetPF2Volume := Amp Shr 3;
End; { GetPF2Volume }
*)
Procedure HandlePitfall2(AtariSeg: PASeg; BSValue,Addr,XY,Acc,PC: Word);
Var
  B       : Byte;
  I,W     : Word;
  Opcode  : Byte;
  Opcode1 : Byte;
  OTyp    : String[3];
  X       : Word;
  Y       : Word;
  Value   : Integer;
  M       : String[3];

  Function GetSound: Byte;
  Type Ar = Array[0..$7F] Of Byte;
  Var
    _WaveLen : Array[1..4] Of Byte; { The fourth byte is unused in these arrays }
    _Pulse   : Array[1..4] Of Byte;
    _Phase   : Array[1..4] Of Byte;
    _Signal  : Array[1..4] Of Byte;
    L        : LongInt;
    P        : ^Ar;
{    Incr     : Word;}

  Begin
{
    Incr := Trunc((PF2Inc - OldPF2Inc) / 33.3);
    If SoundQueue_Num + Incr > 1023 Then Incr := 1023 - SoundQueue_Num;
    If Incr > 0 Then
    Begin
      ProcessSound(@(SoundQueue[SoundQueue_In]),Incr);
      SoundQueue_In := (SoundQueue_In + Incr) And 1023;
}
{      GetSound := GetPF2Volume(Incr);}
{      Inc(SoundQueue_Num,Incr);
    End;
}

    P := Pointer(LongInt(AtariSeg) + $1000);
    Asm
      LES   DI,DWORD PTR P

      { Create a three-byte mask }

      MOV   SI,0FFFFh
      DB    _32BIT_OPERAND
      ROL   SI,16
      MOV   SI,0FFh
      DB    _32BIT_OPERAND
      ROL   SI,16

      { Retrieve the sound parameters }

      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR WaveLen
      DB    _32BIT_OPERAND
      MOV   BX,WORD PTR Pulse
      DB    _32BIT_OPERAND
      MOV   CX,WORD PTR Phase
      DB    _32BIT_OPERAND
      MOV   DX,WORD PTR Signal

      { AND with the mask to ensure that the fourth byte is zero }

      DB    _32BIT_OPERAND
      AND   AX,SI
      DB    _32BIT_OPERAND
      AND   BX,SI
      DB    _32BIT_OPERAND
      AND   CX,SI
      DB    _32BIT_OPERAND
      AND   DX,SI

      { Write the masked bytes to local copies }

      DB    _32BIT_OPERAND
      MOV   WORD PTR _WaveLen,AX
      DB    _32BIT_OPERAND
      MOV   WORD PTR _Pulse,BX
      DB    _32BIT_OPERAND
      MOV   WORD PTR _Phase,CX
      DB    _32BIT_OPERAND
      MOV   WORD PTR _Signal,DX

      { Get the new parameters }

      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR [ES:DI + 45h]
      DB    _32BIT_OPERAND
      MOV   BX,WORD PTR [ES:DI + 4Dh]
      DB    _32BIT_OPERAND
      MOV   CX,WORD PTR [ES:DI + 55h]
      DB    _32BIT_OPERAND
      MOV   DX,WORD PTR [ES:DI + 5Dh]

      { AND the new parameters with the byte masks }

      DB    _32BIT_OPERAND
      AND   AX,SI
      DB    _32BIT_OPERAND
      AND   BX,SI
      DB    _32BIT_OPERAND
      AND   CX,SI
      DB    _32BIT_OPERAND
      AND   DX,SI

      { Write the new parameters, forcing them to be in range }

      DB    _32BIT_OPERAND
      MOV   WORD PTR WaveLen,AX

      DB    _32BIT_OPERAND
      SHR   DX,4

      DB    _32BIT_OPERAND
      MOV   WORD PTR Pulse,BX


      AND   DX,0303h
      DB    _32BIT_OPERAND
      ROL   DX,16
      AND   DX,0303h
      DB    _32BIT_OPERAND
      ROL   DX,16

      DB    _32BIT_OPERAND
      MOV   WORD PTR Phase,CX
      DB    _32BIT_OPERAND
      MOV   WORD PTR Signal,DX

      { Use ESI as a status variable }

      DB    _32BIT_OPERAND
      SUB   SI,SI

      { See if any parameters have changed }

      DB    _32BIT_OPERAND
      CMP   AX,WORD PTR _WaveLen
      JNE   @L1
      DB    _32BIT_OPERAND
      CMP   BX,WORD PTR _Pulse
      JNE   @L1
      DB    _32BIT_OPERAND
      CMP   CX,WORD PTR _Phase
      JNE   @L1
      DB    _32BIT_OPERAND
      CMP   DX,WORD PTR _Signal
      JNE   @L1
      JMP   @L2
@L1:
      DB    _32BIT_OPERAND
      INC   SI
@L2:
      DB    _32BIT_OPERAND
      MOV   WORD PTR L,SI
    End; { Asm }
    If L <> 0 Then GetSound := AudC[0] Xor 1 Else GetSound := AudC[0];
{
    If (WaveLen[1] <> _WaveLen[1]) Or
       (WaveLen[2] <> _WaveLen[2]) Or
       (WaveLen[3] <> _WaveLen[3]) Or
       (Pulse[1] <> _Pulse[1]) Or
       (Pulse[2] <> _Pulse[2]) Or
       (Pulse[3] <> _Pulse[3]) Or
       (Phase[1] <> _Phase[1]) Or
       (Phase[2] <> _Phase[2]) Or
       (Phase[3] <> _Phase[3]) Or
       (Signal[1] <> _Signal[1]) Or
       (Signal[2] <> _Signal[2]) Or
       (Signal[3] <> _Signal[3]) Then GetSound := AtariSeg[$1006] Xor 1 Else GetSound := AtariSeg[$1006];
}
  End; { GetSound }
(*
  Function GetSound1: Byte;
  Type Ar = Array[0..$7F] Of Byte;
  Var
    P       : ^Ar;
    Amp     : Byte;

  Begin
    P := Pointer(LongInt(AtariSeg) + $1000);

    Asm
      LES   DI,DWORD PTR P

      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR [ES:DI + 45h]
      DB    _32BIT_OPERAND
      MOV   BX,WORD PTR [ES:DI + 4Dh]
      DB    _32BIT_OPERAND
      MOV   CX,WORD PTR [ES:DI + 55h]
      DB    _32BIT_OPERAND
      MOV   DX,WORD PTR [ES:DI + 5Dh]

      DB    _32BIT_OPERAND
      MOV   WORD PTR WaveLen,AX
      DB    _32BIT_OPERAND
      MOV   WORD PTR Pulse,BX
      DB    _32BIT_OPERAND
      MOV   WORD PTR Phase,CX

      DB    _32BIT_OPERAND
      SHR   DX,4
      AND   DX,0303h
      MOV   WORD PTR Signal,DX
      DB    _32BIT_OPERAND
      SHR   DX,16
      AND   DX,0303h
      MOV   WORD PTR Signal[2],DX

    End; { Asm }

{
    WaveLen[1] := P^[$45];
    WaveLen[2] := P^[$46];
    WaveLen[3] := P^[$47];

    Pulse[1]   := P^[$4D];
    Pulse[2]   := P^[$4E];
    Pulse[3]   := P^[$4F];
}
    If Pulse[1] > WaveLen[1] Then Pulse[1] := 0;
    If Pulse[2] > WaveLen[2] Then Pulse[2] := 0;
    If Pulse[3] > WaveLen[3] Then Pulse[3] := 0;
{
    Phase[1]   := P^[$55];
    Phase[2]   := P^[$56];
    Phase[3]   := P^[$57];

    Signal[1]  := (P^[$5D] Shr 4) And 3;
    Signal[2]  := (P^[$5E] Shr 4) And 3;
    Signal[3]  := (P^[$5F] Shr 4) And 3;
}
    Amp := 0;

(
    Inc(Wave[1]);
    Inc(Wave[2]);
    Inc(Wave[3]);

    _Wave[1] := Wave[1] + Phase[1];
    _Wave[2] := Wave[2] + Phase[2];
    _Wave[3] := Wave[3] + Phase[3];

    If WaveLen[1] > 0
     Then _Wave[1] := _Wave[1] Mod WaveLen[1]
     Else _Wave[1] := 0;

    If WaveLen[2] > 0
     Then _Wave[2] := _Wave[2] Mod WaveLen[2]
     Else _Wave[2] := 0;

    If WaveLen[3] > 0
     Then _Wave[3] := _Wave[3] Mod WaveLen[3]
     Else _Wave[3] := 0;

    Case Signal[1] Of
      1: Amp := 4;
      3: If _Wave[1] <= Pulse[1] Then Amp := 4;
    End; { Case }

    Case Signal[2] Of
      1: Inc(Amp,5);
      3: If _Wave[2] <= Pulse[2] Then Inc(Amp,5);
    End; { Case }

    Case Signal[3] Of
      1: Inc(Amp,6);
      3: If _Wave[3] <= Pulse[3] Then Inc(Amp,6);
    End; { Case }
)
    GetSound1 := Amp;
  End; { GetSound1 }
*)
Begin
  If BSValue = $CE Then
  Begin
    If (Addr >= $1008) And (Addr <= $103F) Then
    Begin
      I := Addr And 7;
      If Addr >= $1038 Then
      Begin
        B := $FF;
        Dec(PF2Read[I]);
      End
      Else
       If Addr >= $1028 Then
       Begin
         B := PF2Dump^[(PF2Read[I] And $7FF)];
         Dec(PF2Read[I]);
       End
       Else
        If Addr >= $1020 Then
        Begin
          B := PF2Dump^[(PF2Read[I] And $7FF)];
          Asm
            MOV  AL,B
            RCR  AL,1
            RCL  AH,1
            RCR  AL,1
            RCL  AH,1
            RCR  AL,1
            RCL  AH,1
            RCR  AL,1
            RCL  AH,1
            RCR  AL,1
            RCL  AH,1
            RCR  AL,1
            RCL  AH,1
            RCR  AL,1
            RCL  AH,1
            RCR  AL,1
            RCL  AH,1
            MOV  B,AH
          End; { Asm }
          Dec(PF2Read[I]);
        End
        Else
         If Addr >= $1018 Then
         Begin
           B := PF2Dump^[(PF2Read[I] And $7FF)];
           B := (B Shr 4) + (B Shl 4);
           Dec(PF2Read[I]);
         End
         Else
          If Addr >= $1010 Then
          Begin
            B := PF2Dump^[(PF2Read[I] And $7FF)];
            If PF2Read[I] = PF2Read[I + 8]  Then PF2ReadB[I] := True;
            If PF2Read[I] = PF2Read[I + 16] Then PF2ReadB[I] := False;
            If Not PF2ReadB[I] Then B := 0;
            Dec(PF2Read[I]);
          End
          Else
           If Addr >= $1008 Then
           Begin
             B := PF2Dump^[(PF2Read[I] And $7FF)];
             Dec(PF2Read[I]);
           End;
      AtariSeg^[Addr]        := B;
      AtariSeg^[Addr + $800] := B;
      PF2Read[I + 8]  := (PF2Read[I + 8]  And $FF) + (PF2Read[I] And $700);
      PF2Read[I + 16] := (PF2Read[I + 16] And $FF) + (PF2Read[I] And $700);
    End
    Else
     Begin
       If Addr = $1006
        Then AtariSeg^[$1006] := GetSound
        Else
         If (Addr >= $1000) And (Addr <= $1003) Then
         Begin
           AtariSeg^[Addr] :=
            PF2Dump^[2048 + Rand[Addr - $1000]];
           Inc(Rand[Addr - $1000]);
           If Rand[Addr - $1000] = $255 Then Rand[Addr - $1000] := 0;
         End;
     End;
  End
  Else
   If BSValue = $CF Then
   Begin
     If (Addr >= $1040) And (Addr <= $105F){ And ((Addr And 7) < 5)} Then
     Begin
       Opcode := AtariSeg^[PC];
       X      := XY And $FF;
       Y      := XY Shr 8;
       Value  := -1;
       M      := Mnem[Opcode];
       Asm
         MOV   AX,WORD PTR M[1]
         MOV   WORD PTR W,AX
         MOV   AL,BYTE PTR M[3]
         MOV   BYTE PTR B,AL
       End; { Asm }
       If W = $5453 Then      { "ST" }
       Begin
         If B = 65 Then Value := Acc Else  { "A" }
          If B = 88 Then Value := X Else   { "X" }
           If B = 89 Then Value := Y;      { "Y" }
  {     If Mnem[Opcode] = 'STA' Then Value := Acc Else
        If Mnem[Opcode] = 'STX' Then Value := X Else
         If Mnem[Opcode] = 'STY' Then Value := Y;}
         If Value >= 0 Then
         Begin
           AtariSeg^[Addr] := Value;

           If (Addr And 7 >= 5) Then
           Begin
             Wave[(Addr And 7) - 4] := 0;
             _Wave[(Addr And 7) - 4] := 0;
           End;

{$IFDEF P2LOG}
{           If (Addr And 7 >= 5) Then}
            WriteLn(Listing,HexByte(Value),' --> [',HexWord(Addr),']');
{$ENDIF}
           If (Addr And 7) < 5 Then
           Begin
             I := Addr And 7;
             If (Addr And $10) <> 0 Then
             Begin
               If (Addr And 8) = 0
                Then PF2Read[I] := (PF2Read[I] And $700) + Value
                Else
                Begin
                  PF2Read[I]      := (PF2Read[I]      And $FF)   + ((Value Shl 8) And $700);
                  PF2Read[I + 8]  := (PF2Read[I + 8]  And $FF)   + ((Value Shl 8) And $700);
                  PF2Read[I + 16] := (PF2Read[I + 16] And $FF)   + ((Value Shl 8) And $700);
                  PF2ReadB[I] := False;
                End;
             End
             Else
             Begin
               If (Addr And 8) = 0
                Then PF2Read[I + 8]  := (PF2Read[I + 8]  And $700) + Value
                Else PF2Read[I + 16] := (PF2Read[I + 16] And $700) + Value;
             End;
           End;
         End;
       End;
     End;
   End;
End; { HandlePitfall2 }


Procedure LoadDump;
Var F: File;
  D : Array[0..2047] Of Byte;
  I,J : Integer;

Begin
  GetMem(PF2Dump,2048 + 255);
(*
  If Exist('PIT2DATA.BIN') Then
  Begin
    Assign(F,'PIT2DATA.BIN');
    Reset(F,1);
    BlockRead(F,D,2048);
    BlockRead(F,PF2Dump^[2048],255);
    Close(F);
    J := 2047;
    For I := 0 To 2047 Do
    Begin
      PF2Dump^[I] := D[J];
      Dec(J);
      If J < 0 Then J := 2047;
    End; { For I }
  End;
*)
End; { LoadDump }


Procedure FillDump(Const P: Pointer);
Var
  D   : Array[0..2047] Of Byte;
  I,J : Integer;

Begin
  Move(Mem[Seg(P^):Ofs(P^) + 8192],D,2048);
  Move(Mem[Seg(P^):Ofs(P^) + 8192 + 2048],PF2Dump^[2048],255);
  J := 2047;
  For I := 0 To 2047 Do
  Begin
    PF2Dump^[I] := D[J];
    Dec(J);
    If J < 0 Then J := 2047;
  End; { For I }
End; { FillDump }


Begin
  SPSearch   := 0;
  SPWrite    := False;
  SPWriteVal := 0;
  SPBoot     := False;
{$IFDEF LOG }
  Assign(Listing,'STARPATH.LOG');
  ReWrite(Listing);
  OldExitProc := ExitProc;
  ExitProc    := @NewExitProc;
{$ENDIF}
{$IFDEF P2LOG }
  Assign(Listing,'PITFALL2.LOG');
  ReWrite(Listing);
  OldExitProc := ExitProc;
  ExitProc    := @NewExitProc;
{$ENDIF}
  LoadDump;
  FillChar(Wave,SizeOf(Wave),#0);
  FillChar(Rand,SizeOf(Rand),#0);
  FillChar(PF2ReadB,SizeOf(PF2ReadB),#0);
End.